<?php get_header();

			/* Translation */
			$blake_von_hauer_tra_SearchResults = esc_html__( 'SEARCH RESULTS', 'blake-von-hauer' );
			$blake_von_hauer_tra_Category = esc_html__( 'CATEGORY', 'blake-von-hauer' );
			$blake_von_hauer_tra_Tag = esc_html__( 'TAG', 'blake-von-hauer' );
			$blake_von_hauer_tra_Archives = esc_html__( 'ARCHIVES', 'blake-von-hauer' );
			
			if ( get_theme_mod( 'blake_von_hauer_IgnorePOT', 0 ) ) {
				
				$blake_von_hauer_tra_SearchResults = get_theme_mod( 'blake_von_hauer_tra_SearchResults', 'SEARCH RESULTS' );
				$blake_von_hauer_tra_Category = get_theme_mod( 'blake_von_hauer_tra_Category', 'CATEGORY' );
				$blake_von_hauer_tra_Tag = get_theme_mod( 'blake_von_hauer_tra_Tag', 'TAG' );
				$blake_von_hauer_tra_Archives = get_theme_mod( 'blake_von_hauer_tra_Archives', 'ARCHIVES' );
			
			}
			/* */
			
			/* Radio Default Values */
			$blake_von_hauer_opt_Layout = get_theme_mod( 'blake_von_hauer_opt_Layout_Archive', '1col_sidebar' );
			/* */
			
			/* Style A Check for (1 + X) Column Layouts */
			$blake_von_hauer_postPerPage = get_option( 'posts_per_page' );
			$blake_von_hauer_styleA_count = get_theme_mod( 'blake_von_hauer_styleA_count_Archive', 0 );
			$blake_von_hauer_styleB_count = get_theme_mod( 'blake_von_hauer_styleB_count_Archive', 0 );
			$blake_von_hauer_styleZ_count = get_theme_mod( 'blake_von_hauer_styleZ_count_Archive', 0 );
			if ( $blake_von_hauer_styleA_count + $blake_von_hauer_styleB_count + $blake_von_hauer_styleZ_count > $blake_von_hauer_postPerPage ) { $blake_von_hauer_styleA_count = $blake_von_hauer_postPerPage; }
			if ( $blake_von_hauer_styleA_count + $blake_von_hauer_styleB_count + $blake_von_hauer_styleZ_count < $blake_von_hauer_postPerPage ) { $blake_von_hauer_styleA_count = $blake_von_hauer_postPerPage - ( $blake_von_hauer_styleB_count + $blake_von_hauer_styleZ_count ); }
			if ( $blake_von_hauer_styleA_count % 2 == 0 ) { $styleA_odd_check = 0; } else { $styleA_odd_check = 1; }
			if ( $blake_von_hauer_styleA_count % 3 == 0 ) { $styleA_odd_check_3 = 0; } else if ( $blake_von_hauer_styleA_count % 3 == 1 ) { $styleA_odd_check_3 = 1; } else { $styleA_odd_check_3 = 2; }
			/* */
			
			$blake_von_hauer_pageHeader = '';
			
			if ( !get_theme_mod( 'blake_von_hauer_sh_FilterBar_Word', 0 ) ) {
				
				if ( is_search() ) {
	
					$blake_von_hauer_pageHeader = esc_html( get_search_query( false ) );
				
				} else if ( is_category() ) {
				
					$blake_von_hauer_pageHeader = single_cat_title( '', false );
				
				} else if ( is_tag() ) {
				
					$blake_von_hauer_pageHeader = single_tag_title( '', false );
				
				} else if ( is_author() ) {
				
					the_post();
					$avatar_img = get_avatar( get_the_author_meta( 'user_email' ) , 60 );
					$blake_von_hauer_pageHeader =  get_the_author();
					rewind_posts();
				
				} else if ( is_day() ) {
				
					$blake_von_hauer_pageHeader =  get_the_date();
				
				} else if ( is_month() ) {
				
					$blake_von_hauer_pageHeader =  get_the_date( 'F Y' );
				
				} else if ( is_year() ) {
				
					$blake_von_hauer_pageHeader =  get_the_date( 'Y' );
				
				} else {
				
					$blake_von_hauer_pageHeader =  $blake_von_hauer_tra_Archives;
				
				}
				
			} else {
			
				if ( is_search() ) {
				
					$blake_von_hauer_pageHeader = $blake_von_hauer_tra_SearchResults . ' / ' . esc_html( get_search_query( false ) );
					
				} else if ( is_category() ) {
					
					$blake_von_hauer_pageHeader = single_cat_title( $blake_von_hauer_tra_Category . ' / ', false );
					
				} else if ( is_tag() ) {
					
					$blake_von_hauer_pageHeader = single_tag_title( $blake_von_hauer_tra_Tag . ' / ', false );
					
				} else if ( is_author() ) {
					
					the_post();
					$avatar_img = get_avatar( get_the_author_meta( 'user_email' ) , 60 );
					$blake_von_hauer_pageHeader = get_the_author();
					rewind_posts();
					
				} else if ( is_day() ) {
					
					$blake_von_hauer_pageHeader =  $blake_von_hauer_tra_Archives . ' / ' . get_the_date();
					
				} else if ( is_month() ) {
					
					$blake_von_hauer_pageHeader =  $blake_von_hauer_tra_Archives . ' / ' . get_the_date( 'F Y' );
					
				} else if ( is_year() ) {
					
					$blake_von_hauer_pageHeader =  $blake_von_hauer_tra_Archives . ' / ' . get_the_date( 'Y' );
					
				} else {
					
					$blake_von_hauer_pageHeader =  $blake_von_hauer_tra_Archives;
				
				}
			
			}
			
			?>
			            
            <div class="clearfix main-container<?php echo blake_von_hauer_applyLayout(); ?>">            
                <div class="clearfix site-content<?php echo blake_von_hauer_applyLayout(); ?>">
                
                <?php if ( get_theme_mod( 'blake_von_hauer_sh_FilterBar', 1 ) ) { ?>
                    <!-- filter bar -->
                    <div class="clearfix mb20">
                        <div class="filter-bar clearfix">
	                        <?php if ( is_author() ) { ?><div class="filter-bar-author"><?php echo wp_kses_post( $avatar_img ); ?></div><?php } else { ?>
                            	<div class="filter-bar-arrow"><?php echo '<i class="fa fa-angle-right"></i>'; ?></div>
                            <?php } ?>
                            <div class="table-cell-middle">
                                <div class="fs20 blake-von-hauer-font-1 uppr"><?php echo esc_attr( $blake_von_hauer_pageHeader ); ?></div>
                            </div>
                        </div>
                    </div><!-- /filter bar -->
                <?php } ?>
                
                <!-- wrapper -->
                <div class="wrapper clearfix">
            
                <?php
        
                $blake_von_hauer_counter = 0;
        
                if ( have_posts() ) :
                    while ( have_posts() ) : the_post();
                    
                    if ( $blake_von_hauer_opt_Layout == '2col' || $blake_von_hauer_opt_Layout == '2col_sidebar' ) {
                            
                            // Open & close row in every 2 entries for 2 columns layout
                                
                            if ( $blake_von_hauer_counter % 2 == 0 ) { ?>
                            
                                <!-- row -->
                                <div class="row-1-2 clearfix">
                            
                        <?php }
                                    
                            get_template_part( 'content', get_post_format() );
                            $blake_von_hauer_counter += 1;
                                    
                            if ( $blake_von_hauer_counter % 2 == 0 || $blake_von_hauer_counter == $wp_query->post_count ) { ?>
                            
                                </div><!-- /row -->
                                            
                        <?php }
                        
                        } else if ( $blake_von_hauer_opt_Layout == '1_2col' || $blake_von_hauer_opt_Layout == '1_2col_sidebar' ) {
                        
                        // Open & close row for "A Style" entries and then in every 2 entries for 1 + 2 columns layout
												
						if ( $blake_von_hauer_counter <= $blake_von_hauer_styleA_count - 1 ) { ?>
						
							<!-- row -->
							<div class="row-1-1-2 clearfix">
							
						<?php } else {
							
							if ( $blake_von_hauer_counter % 2 == $styleA_odd_check ) { ?>
							
								<!-- row -->
								<div class="row-1-2 clearfix">
							
						<?php }
					
						}
                                
                        get_template_part( 'content', get_post_format() );
                        $blake_von_hauer_counter += 1;
                                
                        if ( $blake_von_hauer_counter <= $blake_von_hauer_styleA_count || ( $blake_von_hauer_counter > $blake_von_hauer_styleA_count && $blake_von_hauer_counter % 2 == $styleA_odd_check ) || $blake_von_hauer_counter == $wp_query->post_count ) { ?>
                        
                            </div><!-- /row -->
                                        
                    <?php }
                    
                    } else if ( $blake_von_hauer_opt_Layout == '3col' ) {
                            
                            // Open & close row in every 3 entries for 3 columns layout
                                
                            if ( $blake_von_hauer_counter % 3 == 0 ) { ?>
                            
                                <!-- row -->
                                <div class="row-1-3 clearfix">
                            
                        <?php }
                                    
                            get_template_part( 'content', get_post_format() );
                            $blake_von_hauer_counter += 1;
                                    
                            if ( $blake_von_hauer_counter % 3 == 0 || $blake_von_hauer_counter == $wp_query->post_count ) { ?>
                            
                                </div><!-- /row -->
                                            
                        <?php }
                        
                    } else if ( $blake_von_hauer_opt_Layout == '2_3col' ) {
                        
                        // Open & close row for the first 2 entries and then in every 3 entries for 3 columns layout
						
						if ( $blake_von_hauer_counter == 0 ) { ?>
                        
                        	<!-- row -->
                            <div class="row-2-3 clearfix">
                            
                     	<?php } else {
                            
                        if ( $blake_von_hauer_counter % 3 == 2 ) { ?>
                        
                            <!-- row -->
                            <div class="row-1-3 clearfix">
                        
                    <?php }
					
						}
                                
                        get_template_part( 'content', get_post_format() );
                        $blake_von_hauer_counter += 1;
                                
                        if ( $blake_von_hauer_counter == 2 || $blake_von_hauer_counter % 3 == 2 || $blake_von_hauer_counter == $wp_query->post_count ) { ?>
                        
                            </div><!-- /row -->
                                        
                    <?php }
                    
                    } else if ( $blake_von_hauer_opt_Layout == '1_3col' ) {
                        
						// Open & close row for "A Style" entries and then in every 3 entries for 1 + 3 columns layout
						
						if ( $blake_von_hauer_counter <= $blake_von_hauer_styleA_count - 1 ) { ?>
						
							<!-- row -->
							<div class="row-1-1-2 clearfix">
							
						<?php } else {
							
							if ( $blake_von_hauer_counter % 3 == $styleA_odd_check_3 ) { ?>
							
								<!-- row -->
								<div class="row-1-3 clearfix">
							
						<?php }
					
						}
								
						get_template_part( 'content', get_post_format() );
						$blake_von_hauer_counter += 1;
								
						if ( $blake_von_hauer_counter <= $blake_von_hauer_styleA_count || ( $blake_von_hauer_counter > $blake_von_hauer_styleA_count && $blake_von_hauer_counter % 3 == $styleA_odd_check_3 ) || $blake_von_hauer_counter == $wp_query->post_count ) { ?>
						
							</div><!-- /row -->
										
						<?php }
                    
                    } else {
                            
                            get_template_part( 'content', get_post_format() );
                            $blake_von_hauer_counter += 1;
                            
                        }
                                        
                        endwhile;
                        
                    else :
                        
                    get_template_part( 'nothing-found' );
                        
                    endif;
                    
                    wp_reset_postdata();
                        
                    ?>
                                                    
                </div><!-- /wrapper -->
                
                <?php blake_von_hauer_Pagination(); ?>
            
            </div><!-- /site-content -->
		</div><!-- /main-container -->
                
    </div><!-- /article-wrapper-outer -->
		
    <!-- sidebar -->
    
    <?php
                
        if ( $blake_von_hauer_opt_Layout == '1col_sidebar' || $blake_von_hauer_opt_Layout == '2col_sidebar' || $blake_von_hauer_opt_Layout == '1_2col_sidebar' ) {

            if ( get_theme_mod( 'blake_von_hauer_ExtraSidebar_Archive' ) ) {
                    
                echo '<div class="sidebar clearfix">';    
                    dynamic_sidebar( 'blake_von_hauer_sidebar_archive' );                        
                echo '</div>';
                    
            } else {

                get_sidebar();
                
            }
                    
        }
            
    ?>
    
    <!-- /sidebar -->
	
</div><!-- /site-mid -->
            
<?php get_footer(); ?>