<?php

/* Translation */
$blake_von_hauer_tra_Comment = esc_html__( 'Comment', 'blake-von-hauer' );
$blake_von_hauer_tra_Comments = esc_html__( 'Comments', 'blake-von-hauer' );
$blake_von_hauer_tra_Name = esc_html__( 'NAME', 'blake-von-hauer' );
$blake_von_hauer_tra_Email = esc_html__( 'E-MAIL', 'blake-von-hauer' );
$blake_von_hauer_tra_Website = esc_html__( 'WEBSITE', 'blake-von-hauer' );
$blake_von_hauer_tra_MustBeLogged = esc_html__( 'YOU MUST BE LOGGED IN TO POST A COMMENT', 'blake-von-hauer' );
$blake_von_hauer_tra_Logged = esc_html__( 'LOGGED IN', 'blake-von-hauer' );
$blake_von_hauer_tra_LogOut = esc_html__( 'LOG OUT', 'blake-von-hauer' );
$blake_von_hauer_tra_LeaveReply = esc_html__( 'Leave a Reply', 'blake-von-hauer' );
$blake_von_hauer_tra_CancelReply = esc_html__( 'CANCEL REPLY', 'blake-von-hauer' );
$blake_von_hauer_tra_PostComment = esc_html__( 'POST COMMENT', 'blake-von-hauer' );
$blake_von_hauer_tra_Cookie = esc_html__( 'Save my name, email, and website in this browser for the next time I comment', 'blake-von-hauer' );

if ( get_theme_mod( 'blake_von_hauer_IgnorePOT', 0 ) ) {

	$blake_von_hauer_tra_Comment = get_theme_mod( 'blake_von_hauer_tra_Comment', 'Comment' );
	$blake_von_hauer_tra_Comments = get_theme_mod( 'blake_von_hauer_tra_Comments', 'Comments' );
	$blake_von_hauer_tra_Name = get_theme_mod( 'blake_von_hauer_tra_Name', 'NAME' );
	$blake_von_hauer_tra_Email = get_theme_mod( 'blake_von_hauer_tra_Email', 'E-MAIL' );
	$blake_von_hauer_tra_Website = get_theme_mod( 'blake_von_hauer_tra_Website', 'WEBSITE' );
	$blake_von_hauer_tra_MustBeLogged = get_theme_mod( 'blake_von_hauer_tra_MustBeLogged', 'YOU MUST BE LOGGED IN TO POST A COMMENT' );
	$blake_von_hauer_tra_Logged = get_theme_mod( 'blake_von_hauer_tra_Logged', 'LOGGED IN' );
	$blake_von_hauer_tra_LogOut = get_theme_mod( 'blake_von_hauer_tra_LogOut', 'LOG OUT' );
	$blake_von_hauer_tra_LeaveReply = get_theme_mod( 'blake_von_hauer_tra_LeaveReply', 'Leave a Reply' );
	$blake_von_hauer_tra_CancelReply = get_theme_mod( 'blake_von_hauer_tra_CancelReply', 'CANCEL REPLY' );
	$blake_von_hauer_tra_PostComment = get_theme_mod( 'blake_von_hauer_tra_PostComment', 'POST COMMENT' );
	$blake_von_hauer_tra_Cookie = get_theme_mod( 'blake_von_hauer_tra_Cookie', 'Save my name, email, and website in this browser for the next time I comment' );

}
/* */

if ( ( comments_open() || get_comments_number() ) && !post_password_required() ) { ?>

    <!-- comments-container -->
    <div class="comments-container clearfix">
        <!-- comments-outer -->
        <div class="comments-outer<?php echo blake_von_hauer_applyLayout(); ?>">
            <!-- comments -->
            <div id="comments" class="comments">

                <div class="blake-von-hauer-font-1 comments-hdr"><?php comments_number( '0 ' . esc_attr( $blake_von_hauer_tra_Comment ), '1 ' . esc_attr( $blake_von_hauer_tra_Comment ), '% ' . esc_attr( $blake_von_hauer_tra_Comments ) ); ?></div>

                <div class="comments-list">
                	<ul>

                    <?php

                        wp_list_comments( array(
                            'avatar_size' => 40,
                            'max_depth' => 3,
                            'style' => 'ul',
                            'callback' => 'blake_von_hauer_setCommentItem',
                            'type' => 'all'
                        ) );

                    ?>

                    </ul>
                </div>

                <?php if ( get_comment_pages_count() > 1 && get_option( 'page_comments' ) ) { ?>

                <div class="comments-paging fs14 blake-von-hauer-font-3 fw700 fst-italic"><?php echo paginate_comments_links( array( 'prev_text' => '<i class="fa fa-chevron-left"></i>', 'next_text' => '<i class="fa fa-chevron-right"></i>' ) ); ?></div>

                <?php } ?>

                    <?php

                        $req = get_option( 'require_name_email' );
                        $aria_req = ( $req ? " aria-required=true" : '' );

                        $blake_von_hauer_tra_fields = array (
                            'author' => '<div class="comment-form-author fs14 blake-von-hauer-font-3 fw700 fst-italic comment-input-hdr">' . '<label for="author">' . esc_attr( $blake_von_hauer_tra_Name ) . ( $req ? ' <span class="required"> *</span>' : '' ) . '</label></div> ' .
                                        '<input id="author" name="author" type="text" value="' . esc_attr( $commenter['comment_author'] ) . '" ' . esc_attr( $aria_req ) . ' />',
                            'email' => '<div class="comment-form-email fs14 blake-von-hauer-font-3 fw700 fst-italic comment-input-hdr"><label for="email">' . esc_attr( $blake_von_hauer_tra_Email ) . ( $req ? ' <span class="required"> *</span>' : '' ) . '</label></div> ' .
                                        '<input id="email" name="email" ' . 'type="text"' . ' value="' . esc_attr( $commenter['comment_author_email'] ) . '" aria-describedby="email-notes"' . esc_attr( $aria_req ) . ' />',
                            'url' => '<div class="comment-form-url fs14 blake-von-hauer-font-3 fw700 fst-italic comment-input-hdr"><label for="url">' . esc_attr( $blake_von_hauer_tra_Website ) . '</label></div> ' .
                                        '<input id="url" name="url" ' . 'type="text"' . ' value="' . esc_attr( $commenter['comment_author_url'] ) . '" />',
														'cookies' => '<p class="comment-form-cookies-consent"><input id="wp-comment-cookies-consent" name="wp-comment-cookies-consent" type="checkbox" value="yes"> <label for="wp-comment-cookies-consent">' . esc_html( $blake_von_hauer_tra_Cookie ) . '</label></p>',
                        );

                        $blake_von_hauer_tra_comment_field = '<div class="comment-form-comment fs14 blake-von-hauer-font-3 fw700 fst-italic uppr comment-input-hdr"><label for="comment">' . esc_attr( $blake_von_hauer_tra_Comment ) . '</label></div><textarea id="comment" name="comment" aria-describedby="form-allowed-tags" aria-required="true"></textarea>';

                        $blake_von_hauer_tra_must_log_in = '<div class="must-log-in fs14 blake-von-hauer-font-3 fw700 fst-italic">' . sprintf( '<a href="%s">' . esc_attr( $blake_von_hauer_tra_MustBeLogged ) . '.</a>', wp_login_url(apply_filters( 'the_permalink', get_permalink() ) ) ) . '</div>';

                        $blake_von_hauer_tra_logged_in_as = '<div class="logged-in-as fs14 blake-von-hauer-font-3 fw700 fst-italic">' . sprintf( esc_attr( $blake_von_hauer_tra_Logged ) . ': <a href="%1$s">%2$s</a> / <a href="%3$s">' . esc_attr( $blake_von_hauer_tra_LogOut ) . '</a>', get_edit_user_link(), $user_identity, wp_logout_url( apply_filters( 'the_permalink', get_permalink() ) ) ) . '</div>';

                        comment_form( array(
                            'fields' => $blake_von_hauer_tra_fields,
                            'comment_field' => $blake_von_hauer_tra_comment_field,
                            'comment_notes_after' => '',
                            'logged_in_as' => '',
                            'comment_notes_before' => '',
                            'title_reply' => esc_attr( $blake_von_hauer_tra_LeaveReply ),
                            'title_reply_to' => esc_attr( $blake_von_hauer_tra_LeaveReply ),
                            'cancel_reply_link' => '<span class="blake-von-hauer-font-3 fw700 fst-italic fs14 cancel-display-block">' . esc_attr( $blake_von_hauer_tra_CancelReply ) . '<i class="fa fa-close ml5"></i></span>',
                            'label_submit' => esc_attr( $blake_von_hauer_tra_PostComment ),
                            'must_log_in' => $blake_von_hauer_tra_must_log_in,
                            'logged_in_as' => $blake_von_hauer_tra_logged_in_as
                        ) );
                    ?>

            </div><!-- /comments -->
        </div><!-- /comments-outer -->
    </div><!-- /comments-container -->

<?php }

function blake_von_hauer_setCommentItem( $comment, $args, $depth ) {

	/* Translation */
	$blake_von_hauer_tra_At = esc_html__( 'AT', 'blake-von-hauer' );
	$blake_von_hauer_tra_Reply = esc_html__( 'REPLY', 'blake-von-hauer' );
	$blake_von_hauer_tra_LoginToReply = esc_html__( 'LOG IN TO REPLY', 'blake-von-hauer' );
	$blake_von_hauer_tra_Edit = esc_html__( 'EDIT', 'blake-von-hauer' );
	$blake_von_hauer_tra_Awaiting = esc_html__( 'Comment awaiting approval.', 'blake-von-hauer' );

	if ( get_theme_mod( 'blake_von_hauer_IgnorePOT', 0 ) ) {

		$blake_von_hauer_tra_At = get_theme_mod( 'blake_von_hauer_tra_At', 'AT' );
		$blake_von_hauer_tra_Reply = get_theme_mod( 'blake_von_hauer_tra_Reply', 'REPLY' );
		$blake_von_hauer_tra_LoginToReply = get_theme_mod( 'blake_von_hauer_tra_LoginToReply', 'LOG IN TO REPLY' );
		$blake_von_hauer_tra_Edit = get_theme_mod( 'blake_von_hauer_tra_Edit', 'EDIT' );
		$blake_von_hauer_tra_Awaiting = get_theme_mod( 'blake_von_hauer_tra_Awaiting', 'Comment awaiting approval.' );

	}
	/* */

	$GLOBALS['comment'] = $comment; ?>

	<li <?php comment_class(); ?> id="comment-<?php comment_ID(); ?>">

        <div class="comment-item-outer">

            <div class="comment-item clearfix">

                <?php if ( get_avatar( $comment ) ) { ?><div class="comment-author-img"><?php echo get_avatar( $comment, $args['avatar_size'] ); ?></div><?php } ?>

                <div class="comment-content clearfix">

                	<div class="comment-info">

                        <div class="comment-info-inner">
                            <div class="table-cell-middle">
                                <div class="comment-author-name blake-von-hauer-font-1 fs20"><?php echo get_comment_author_link(); ?></div>
                            </div>
                        </div>

                    </div>

                </div>

            </div>

            <div class="comment-text clearfix<?php if ( get_avatar( $comment ) ) { echo ' comment-text-w-a'; } ?>">

                <?php if ( $comment->comment_approved == '0' ) { ?>

                	<div class="comment-awaiting fs12 fst-italic blake-von-hauer-font-2"><?php echo esc_attr( $blake_von_hauer_tra_Awaiting ); ?></div>

				<?php } ?>

                <div class="comment-date blake-von-hauer-font-3 fw700 fst-italic fs14"><?php printf( '%1$s ' . esc_attr( $blake_von_hauer_tra_At ) . ' %2$s', get_comment_date(),  get_comment_time() ) ?></div>

				<div class="blake-von-hauer-font-2 fs14"><?php comment_text(); ?></div>

                <div class="comment-reply-edit clearfix">

					<?php if ( $depth < 3 ) {

						comment_reply_link( array_merge( $args, array( 'before' => '<div class="btnReply fs14 blake-von-hauer-font-3 fw700 fst-italic">', 'after' => '</div>', 'reply_text' => esc_attr( $blake_von_hauer_tra_Reply ), 'login_text' => esc_attr( $blake_von_hauer_tra_LoginToReply ), 'depth' => $depth, 'max_depth' => $args['max_depth'] ) ), $comment->comment_ID );

					} ?>

                    <?php if ( user_can( wp_get_current_user(), 'administrator' ) ) { ?>

                    <div class="btnEdit fs14 blake-von-hauer-font-3 fw700 fst-italic">
                        <?php edit_comment_link( esc_attr( $blake_von_hauer_tra_Edit ) ); ?>
                    </div>

                    <?php } ?>

                </div>

			</div>

        </div>

<?php } ?>
