<!DOCTYPE html>
<html <?php if ( get_theme_mod( 'blake_von_hauer_IgnorePOT', 0 ) && get_theme_mod( 'blake_von_hauer_tra_Lang' ) ) { echo 'lang="' . esc_attr( get_theme_mod( 'blake_von_hauer_tra_Lang' ) ) . '"'; } else { language_attributes(); } ?>>
	<head>
    	<meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=no">
        <meta charset="<?php bloginfo( 'charset' ); ?>">
        <?php if ( get_theme_mod( 'blake_von_hauer_upload_Favicon' ) && !function_exists( 'wp_site_icon' ) ) { ?><link rel="icon" href="<?php echo esc_url( get_theme_mod( 'blake_von_hauer_upload_Favicon' ) ); ?>"><?php } ?>
        <link rel="pingback" href="<?php esc_url( bloginfo( 'pingback_url' ) ); ?>" />
		<?php wp_head(); ?>
	</head>

<body <?php body_class(); ?>>

    <div class="body-outer">

    	<!-- Sticky Header -->
	    <?php if ( get_theme_mod( 'blake_von_hauer_stickyHeader', 0 ) ) { get_template_part( 'sticky-menu' ); } ?>
        <!-- /Sticky Header -->

        <!-- Mobile Header -->
				<div class="mobile-header clearfix">
					<div class="mobile-logo-outer">
						<div class="mobile-logo-container">
							<?php $stickyLogoPath = '';
							if ( get_theme_mod( 'blake_von_hauer_upload_Logo' ) ) { $stickyLogoPath = get_theme_mod( 'blake_von_hauer_upload_Logo' ); }
							if ( get_theme_mod( 'blake_von_hauer_upload_StickyLogo' ) ) { $stickyLogoPath = get_theme_mod( 'blake_von_hauer_upload_StickyLogo' ); }
							if ( get_theme_mod( 'blake_von_hauer_upload_MobileLogo' ) ) { $stickyLogoPath = get_theme_mod( 'blake_von_hauer_upload_MobileLogo' ); }
							if ( $stickyLogoPath ) { ?><a href="<?php echo esc_url( home_url( '/' ) ); ?>"><img alt="sticky-logo" src="<?php echo esc_url( $stickyLogoPath ); ?>" /></a><?php } else { ?>
								<h1 class="logo-text"><a href="<?php echo esc_url( home_url( '/' ) ); ?>"><?php if ( get_theme_mod( 'blake_von_hauer_text_Logo' ) != '' ) { echo esc_attr( get_theme_mod( 'blake_von_hauer_text_Logo' ) ); } else { bloginfo( 'name' ); } ?></a></h1>
							<?php } ?>
						</div>
					</div>
					<div class="blake-von-hauer-menu-button"><i class="fa fa-navicon"></i></div>
					<div id="touch-menu" class="<?php echo get_theme_mod( 'blake_von_hauer_swiFont_Menu', 'blake-von-hauer-font-3' ); ?> fw700 fst-italic"></div>
				</div>
        <!-- /Mobile Header -->

        <?php if ( get_theme_mod( 'blake_von_hauer_sh_HeaderMenu', 1 ) ) { ?>
        <div class="top-line-outer">
            <div class="top-line-container">
                <div class="top-line-inner clearfix">
                    <div class="header-menu-outer fw700 fst-italic clearfix">
                           <?php
						   $args_header = array(
                                'theme_location' => 'header_menu',
                                'container_class' => 'footer-nav',
                                'menu_id'         => 'header-menu',
                                'depth'		   => '-1',
								'echo' => false,
                                'fallback_cb' => 'blake_von_hauer_assign_HeaderMenu'
                            );

							$nav = wp_nav_menu( $args_header );
							echo str_replace( '</a></li>', '</a></li><li class="nav-sep"></li>', $nav );
							?>
                    </div>
                </div>
            </div>
        </div>
        <?php } ?>

        <div class="site-top clearfix">
            <div class="site-top-container-outer clearfix">
            	<?php if ( get_theme_mod( 'blake_von_hauer_opt_LogoPos', 'logo-bottom' ) == 'logo-top' ) { get_template_part( 'logo' ); } ?>
                <div class="site-top-container clearfix">
                    <?php if ( get_theme_mod( 'blake_von_hauer_opt_LogoPos', 'logo-bottom' ) == 'logo-left' ) { get_template_part( 'logo' ); if ( get_theme_mod( 'blake_von_hauer_opt_MenuPos', 'menu-left' ) == 'menu-right' ) { ?><div class="site-logo-outer-handler"></div><?php } } else { ?><div class="site-logo-left-handler"></div><?php } ?><?php get_template_part( 'primary-menu' ); ob_start( 'blake_von_hauer_compress' ); get_template_part( 'social-search' ); ob_end_flush(); ?>
				</div>
                <?php if ( get_theme_mod( 'blake_von_hauer_opt_LogoPos', 'logo-bottom' ) == 'logo-bottom' ) { get_template_part( 'logo' ); } ?>
            </div>
        </div>

        <?php /* Leaderboard Banner */ if ( function_exists( 'blake_von_hauer_detectLeaderboard' ) ) { blake_von_hauer_detectLeaderboard ( 'below-header' ); } /* */ ?>

        <?php

		/* Slider - Fullwidth */
		if ( get_theme_mod( 'blake_von_hauer_opt_SliderPosition', 'cover' ) == 'full' ) {

			if ( get_theme_mod( 'blake_von_hauer_bpts', '0' ) ) {

				blake_von_hauer_blogPostsToSlider();

			} else {

				blake_von_hauer_placeSlider();

			}

		} /* /Slider - Fullwidth */ ?>

        <div class="site-mid clearfix">

        	<?php /* Slider - Cover */
			if ( get_theme_mod( 'blake_von_hauer_opt_SliderPosition', 'cover' ) == 'cover' ) {

				if ( get_theme_mod( 'blake_von_hauer_bpts', '0' ) ) {

					blake_von_hauer_blogPostsToSlider();

				} else {

					blake_von_hauer_placeSlider();

				}

			} /* /Slider - Cover */

			/* Leaderboard Banner */ if ( function_exists( 'blake_von_hauer_detectLeaderboard' ) ) { blake_von_hauer_detectLeaderboard ( 'above-upper-widgets' ); } /* */

			/* Upper Widgets */
			ob_start( 'blake_von_hauer_compress' );

			if ( is_active_sidebar( 'blake_von_hauer_upper_widgets' ) && ( ( is_home() && get_theme_mod( 'blake_von_hauer_sh_UpperWidgets', 1 ) ) || ( is_single() && get_theme_mod( 'blake_von_hauer_sh_UpperWidgetsPost', 0 ) ) || ( is_archive() && get_theme_mod( 'blake_von_hauer_sh_UpperWidgetsArchive', 0 ) ) || ( is_page() && !is_front_page() && get_theme_mod( 'blake_von_hauer_sh_UpperWidgetsPage', 0 ) ) || ( is_page() && is_front_page() && get_theme_mod( 'blake_von_hauer_sh_UpperWidgetsStatic', 0 ) ) ) ) {

				 if ( get_theme_mod( 'blake_von_hauer_sh_UpperWidgetsFront', 1 ) ) {

					 if ( get_query_var( 'paged' ) <= 1 ) { ?>

						<div class="upper-widget-area">
							<div class="upper-widget-area-inner<?php if ( get_theme_mod( 'blake_von_hauer_upperWidgetsCol', '3col' ) == '2col' ) { echo '-col2'; } ?> clearfix"><?php dynamic_sidebar( 'blake_von_hauer_upper_widgets' ); ?></div>
						</div>

					<?php }

				} else { ?>

					<div class="upper-widget-area">
						<div class="upper-widget-area-inner<?php if ( get_theme_mod( 'blake_von_hauer_upperWidgetsCol', '3col' ) == '2col' ) { echo '-col2'; } ?> clearfix"><?php dynamic_sidebar( 'blake_von_hauer_upper_widgets' ); ?></div>
					</div>

				<?php }

			} ob_end_flush();
			/* /Upper Widgets */

			/* Leaderboard Banner */ if ( function_exists( 'blake_von_hauer_detectLeaderboard' ) ) { blake_von_hauer_detectLeaderboard ( 'below-upper-widgets' ); } /* */

			?>

            <div class="article-wrapper-outer">
