<?php

/*
Plugin Name: BvH Components
Plugin URI: http://www.burnhambox.com/blake-von-hauer
Description: Components for Blake von Hauer theme.
Version: 1.0.2
Author: Burnhambox
Author URI: http://www.burnhambox.com
License: GNU
*/

/* Share Icons */
if ( !function_exists( 'blake_von_hauer_shortcode_share' ) ) {
  function blake_von_hauer_shortcode_share( $atts ) {

    $output = '';

    $a = shortcode_atts( array(
        'ID' => '0',
    ), $atts );

    if ( $a['ID'] == '' ) { $a['ID'] = 0; }

    //

    $blake_von_hauer_sh_SocialBar_Facebook = get_theme_mod( 'blake_von_hauer_sh_SocialBar_Facebook', 1 );
    $blake_von_hauer_sh_SocialBar_Twitter = get_theme_mod( 'blake_von_hauer_sh_SocialBar_Twitter', 1 );
    $blake_von_hauer_sh_SocialBar_Google = get_theme_mod( 'blake_von_hauer_sh_SocialBar_Google', 1 );
    $blake_von_hauer_sh_SocialBar = get_theme_mod( 'blake_von_hauer_sh_SocialBar', 1 );
    if ( !$blake_von_hauer_sh_SocialBar_Facebook && !$blake_von_hauer_sh_SocialBar_Twitter && !$blake_von_hauer_sh_SocialBar_Google ) {
    	$blake_von_hauer_sh_SocialBar = 0;
    }

    // Post Based Show/Hide Share Icons
    $meta_share = get_post_meta( get_the_ID(), 'bvh-share-meta-box-checkbox', true );
    if ( $meta_share ) { $blake_von_hauer_sh_SocialBar = 0; }

    if ( $blake_von_hauer_sh_SocialBar ) {

        $output .= '<div class="clearfix">';
        $output .= '<div class="share-bar blake-von-hauer-font-3 fw700 fst-italic">';
        if ( $blake_von_hauer_sh_SocialBar_Facebook ) { $output .= '<div class="share-icon-outer si-facebook"><a href="https://www.facebook.com/sharer/sharer.php?u=' . esc_url( get_permalink( $a['ID'] ) ) . '" target="_blank">FACEBOOK</a></div>'; }
        if ( $blake_von_hauer_sh_SocialBar_Twitter ) { $output .= '<div class="share-icon-outer si-twitter"><a href="https://twitter.com/share?url=' . esc_url( get_permalink( $a['ID'] ) ) . '" target="_blank">TWITTER</a></div>'; }
        if ( $blake_von_hauer_sh_SocialBar_Google ) { $output .= '<div class="share-icon-outer si-google"><a href="https://plus.google.com/share?url=' . esc_url( get_permalink( $a['ID'] ) ) . '" target="_blank">GOOGLE+</a></div>'; }
        $output .= '</div>';
        $output .= '</div>';

    }

    return $output;

  }
}
add_shortcode( 'blake_von_hauer_share', 'blake_von_hauer_shortcode_share' );
/* */

/* blake_von_hauer_customAdWidget Class */
class blake_von_hauer_customAdWidget extends WP_Widget {

	function __construct() {
		parent::__construct(

			'blake_von_hauer_customAdWidget',
			'Blake Widget: Ads',
			array( 'description' => "A widget for your Ads. Just place your code and you're done." )

		);
	}

	public function form( $instance ) {

		$instance = wp_parse_args( ( array ) $instance, array( 'text' => '' ) );
		$text = esc_textarea( $instance['text'] );

		?>

		<p><textarea class="widefat" rows="16" cols="20" id="<?php echo esc_attr( $this->get_field_id('text') ); ?>" name="<?php echo esc_attr( $this->get_field_name('text') ); ?>"><?php echo wp_kses_post( $text ); ?></textarea></p>

		<?php

	}

	public function update( $new_instance, $old_instance ) {

		$instance = $old_instance;

		if ( current_user_can( 'unfiltered_html' ) ) {

			$instance['text'] =  $new_instance['text'];

		} else {

			$instance['text'] = stripslashes( wp_filter_post_kses( addslashes( $new_instance['text'] ) ) ); // wp_filter_post_kses() expects slashed

		}

		$instance['filter'] = ! empty( $new_instance['filter'] );

		return $instance;

	}

	public function widget( $args, $instance ) {

		extract( $args );

		$text = apply_filters( 'widget_text', empty( $instance['text'] ) ? '' : $instance['text'], $instance );

		if ( $id == 'blake_von_hauer_footer_widgets' ) {

			$fw_col_number = '';
			if ( get_theme_mod( 'blake_von_hauer_footerWidgetsCol', '3col' ) == '2col' ) { $fw_col_number = '-col2'; }
			echo '<div class="widget-item-footer-outer' . esc_attr( $fw_col_number ) . '">';

		} else if ( $id == 'blake_von_hauer_home_widgets' ) {

			$hw_col_number = '';
			if ( get_theme_mod( 'blake_von_hauer_homeWidgetsCol', '2col' ) == '2col' ) { $hw_col_number = '-col2'; }
			if ( get_theme_mod( 'blake_von_hauer_opt_Layout', '1col_sidebar' ) == '1col_sidebar' || get_theme_mod( 'blake_von_hauer_opt_Layout', '1col_sidebar' ) == '2col_sidebar' || get_theme_mod( 'blake_von_hauer_opt_Layout', '1col_sidebar' ) == '1_2col_sidebar' ) { $hw_col_number = '-col2-sidebar'; }
			echo '<div class="widget-item-home-outer' . esc_attr( $hw_col_number ) . '">';

		} else if ( $id == 'blake_von_hauer_upper_widgets' ) {

			$uw_col_number = '';
			if ( get_theme_mod( 'blake_von_hauer_upperWidgetsCol', '3col' ) == '2col' ) { $uw_col_number = '-col2'; }
			echo '<div class="widget-item-upper-outer' . esc_attr( $uw_col_number ) . '">';

		} else {

			echo '<div id="' . esc_attr( $this->id ) . '" class="widget-item">';

		}

		?>

        <div class="textwidget adwidget clearfix"><?php echo !empty( $instance['filter'] ) ? wpautop( $text ) : $text; ?></div>

		<?php

		echo '</div>';

	}

}

/* blake_von_hauer_customCatPostsWidget Class */
class blake_von_hauer_customCatPostsWidget extends WP_Widget {

	function __construct() {
		parent::__construct(

			'blake_von_hauer_customCatPostsWidget',
			'Blake Widget: Category/Tag Posts',
			array( 'description' => "Display the posts belong to a specific category or tag." )

		);
	}

	//Designing the widget, which will be displayed in the admin dashboard widget location.
	public function form( $instance ) {

		$defaults = array( 'name' => 'CATEGORY/TAG POSTS', 'count' => 4, 'styleB_count' => 1, 'styleZ_count' => 3, 'date' => 'on', 'commenticon' => 'on', 'viewall' => 'on', 'category' => 'uncategorized', 'tag' => '', 'show_cats' => 'on', 'exclude_cats' => '', 'exclude_tags' => '', 'exclude_posts' => '' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		?>

        <p><strong>Write a Category Slug:</strong><br />
        <p><input id="get-dropdown-val-cat" name="<?php echo esc_attr( $this->get_field_name( 'category' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['category'] ); ?>" /></p>
        <p><strong>OR - Write a Tag Slug:</strong><br />
        <p><input id="get-dropdown-val-tag" name="<?php echo esc_attr( $this->get_field_name( 'tag' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['tag'] ); ?>" /></p>
        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['show_cats'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'show_cats' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'show_cats' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'show_cats' ) ); ?>">Show Categories <em>(Uncheck for Tags)</em></label>
		</p>

        <hr />

        <p><strong>Excluded Categories:</strong><br />
        <em>Only used if "Show Categories" is checked.<br />Write category IDs you want to hide. Use comma (,) between them. Example: 2,5,8</em>
        <p><input name="<?php echo esc_attr( $this->get_field_name( 'exclude_cats' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['exclude_cats'] ); ?>" /></p>

        <p><strong>Excluded Tags:</strong><br />
        <em>Only used if "Show Categories" is unchecked.<br />Write tag IDs you want to hide.</em>
        <p><input name="<?php echo esc_attr( $this->get_field_name( 'exclude_tags' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['exclude_tags'] ); ?>" /></p>

        <p><strong>Excluded Posts:</strong><br />
        <em>Write post IDs you want to hide.</em>
        <p><input name="<?php echo esc_attr( $this->get_field_name( 'exclude_posts' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['exclude_posts'] ); ?>" /></p>

        <hr />

		<p><strong>Title:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'name' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['name'] ); ?>" style="width: 100%;" /></p>

        <hr />

        <p><strong>Number of posts to show:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['count'] ); ?>" style="width: 50px;" /></p>

        <em>If the sum of Style B and Z is bigger than the number of posts to show, your settings will be ignored and all the posts will be shown in Style B.</em>

        <p>Post count for <strong>Style B</strong>: <input name="<?php echo esc_attr( $this->get_field_name( 'styleB_count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['styleB_count'] ); ?>" style="width: 50px;" /></p>
        <p>Post count for <strong>Style Z</strong>: <input name="<?php echo esc_attr( $this->get_field_name( 'styleZ_count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['styleZ_count'] ); ?>" style="width: 50px;" /></p>

        <em>If the sum of Style B and Z is smaller than the number of posts to show, Style B will take effect to complete the count.</em><p />

        <hr />

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['date'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'date' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'date' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'date' ) ); ?>">Display post date for <strong>Style B</strong></label>
		</p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['commenticon'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'commenticon' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'commenticon' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'commenticon' ) ); ?>">Display comment icon for <strong>Style B</strong></label>
		</p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['viewall'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'viewall' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'viewall' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'viewall' ) ); ?>">Display "View All" button</label>
		</p>

		<?php

	}

	// Update the new values in database
	function update( $new_instance, $old_instance ) {

		$instance = $old_instance;

		$instance['name'] = ( !empty( $new_instance['name'] ) ) ? strip_tags( $new_instance['name'] ) : 'CATEGORY/TAG POSTS';
		$instance['count'] = ( !empty( $new_instance['count'] ) ) ? strip_tags( $new_instance['count'] ) : '4';
		$instance['styleB_count'] = $new_instance['styleB_count'];
		$instance['styleZ_count'] = $new_instance['styleZ_count'];
		$instance['date'] = $new_instance['date'];
		$instance['commenticon'] = $new_instance['commenticon'];
		$instance['viewall'] = $new_instance['viewall'];
		$instance['category'] = $new_instance['category'];
		$instance['tag'] = $new_instance['tag'];
		$instance['show_cats'] = $new_instance['show_cats'];
		$instance['exclude_cats'] = $new_instance['exclude_cats'];
		$instance['exclude_tags'] = $new_instance['exclude_tags'];
		$instance['exclude_posts'] = $new_instance['exclude_posts'];

		return $instance;

	}

	//Display the stored widget information in webpage.
	function widget( $args, $instance ) {

		extract( $args );

		/* Translation */
		$blake_von_hauer_tra_ViewAll = esc_html__( 'VIEW ALL', 'blake-von-hauer' );

		if ( get_theme_mod( 'blake_von_hauer_IgnorePOT', 0 ) ) {

			$blake_von_hauer_tra_ViewAll = get_theme_mod( 'blake_von_hauer_tra_ViewAll', 'VIEW ALL' );

		}
		/* */

		echo wp_kses_post( $before_widget ); //Widget starts to print information

		$defaults = array( 'name' => 'CATEGORY/TAG POSTS', 'count' => 4, 'styleB_count' => 1, 'styleZ_count' => 3, 'date' => 'on', 'commenticon' => 'on', 'viewall' => 'on', 'category' => 'uncategorized', 'tag' => '', 'show_cats' => 'on', 'exclude_cats' => '', 'exclude_tags' => '', 'exclude_posts' => '' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		$name = apply_filters( 'widget_title', $instance['name'] );
		$count = $instance['count'];
		$styleB_count = $instance['styleB_count'];
		$styleZ_count = $instance['styleZ_count'];
		$date = $instance['date'] ? 'true' : 'false';
		$commenticon = $instance['commenticon'] ? 'true' : 'false';
		$viewall = $instance['viewall'] ? 'true' : 'false';
		$category = $instance['category'];
		$tag = $instance['tag'];
		$show_cats = $instance['show_cats'] ? 'true' : 'false';
		$exclude_cats = $instance['exclude_cats'];
		$exclude_tags = $instance['exclude_tags'];
		$exclude_posts = $instance['exclude_posts'];

		/* Combine Widget Listing Settings */

		$w_listing_style = 'b';
		$w_listingOrder = 0;

		if ( $styleB_count + $styleZ_count > $count ) {

			$styleB_count = $count;
			$styleZ_count = 0;

		}

		/* */

		$cpw_rand = rand( 1, 9999999 ); ?>

        <?php

		if ( !empty( $name ) ) {

			echo '<h2 class="blake-von-hauer-font-1 ' . esc_attr( 'cpw-' . $cpw_rand ) .'"><span>' . esc_attr( $name ) . wp_kses_post( $after_title );

			/* function */

			$posts_to_exclude = explode( ',', esc_attr( $exclude_posts ) );

			if ( $show_cats == 'true' ) {

				$cats_to_exclude = explode( ',', esc_attr( $exclude_cats ) );

				$loop_args = array(

					'showposts' => esc_attr( $count ),
					'category_name' => $category,
					'ignore_sticky_posts' => 1,
					'category__not_in' => $cats_to_exclude,
					'post__not_in' => $posts_to_exclude

				);

				$category_id = get_cat_ID( $category );
				$category_link = get_category_link( $category_id );
				$viewall_url = $category_link;

			} else {

				$tags_to_exclude = explode( ',', esc_attr( $exclude_tags ) );

				$loop_args = array(

					'showposts' => esc_attr( $count ),
					'tag' => $tag,
					'ignore_sticky_posts' => 1,
					'tag__not_in' => $tags_to_exclude,
					'post__not_in' => $posts_to_exclude

				);

				$tag_slug = get_term_by( 'slug', $tag, 'post_tag' );
				$tag_id =  $tag_slug->term_id;
				$tag_link = get_tag_link( $tag_id );
				$viewall_url = $tag_link;

			}

			$rPosts = new WP_Query( $loop_args );

			while ( $rPosts->have_posts() ) : $rPosts->the_post();

			//Combine Widget Listing Settings Styles

			$w_listingOrder ++;

			if ( $styleB_count > 0 && ( $w_listingOrder > $count - ( $styleB_count + $styleZ_count ) && $w_listingOrder <= $count - $styleZ_count ) ) {

				$w_listing_style = 'b';

			}

			if ( $styleZ_count > 0 && ( $w_listingOrder > $count - $styleZ_count && $w_listingOrder <= $count ) ) {

				$w_listing_style = 'z';

			} ?>

            <a class="blake-von-hauer-posts-widget <?php echo esc_attr( 'cpw-' . $cpw_rand ); ?>" href="<?php echo esc_url( get_the_permalink() ); ?>">
                <div class="mt20">

                    <?php if ( $w_listing_style == 'b' ) { ?>

                    <?php if ( has_post_thumbnail() ) { ?><div class="listing-img-outer"><?php the_post_thumbnail( 'blake-von-hauer-thumbnail-image' ); ?></div><?php } ?>
                    <div class="listing-box clearfix">
						<?php if ( $date == 'true' ) { ?><div class="blake-von-hauer-font-3 fw700 fst-italic listing-date"><?php echo get_the_date(); ?></div><?php } ?>
                        <div class="listing-title blake-von-hauer-font-1"><?php echo wp_kses_post( the_title() ); ?></div>
                        <?php if ( $commenticon == 'true' && comments_open() ) { ?><div class="blake-von-hauer-font-3 fw700 fst-italic listing-comment-w-o-date clearfix"><div class="listing-comment-icon"><i class="fa fa-comment"></i></div><div class="listing-comment-number"><?php comments_number( '0', '1', '%' ); ?></div></div><?php } ?>
                    </div>

					<?php } else if ( $w_listing_style == 'z' ) { ?>

					<div class="widget-listing-z clearfix">
						<?php if ( has_post_thumbnail() ) { ?><?php echo the_post_thumbnail( 'blake-von-hauer-small-thumbnail-image' ); ?><?php } ?>
                        <div class="widget-listing-z-info <?php if ( has_post_thumbnail() ) { echo 'widget-listing-z-info-with-t'; } ?>">
<div class="table-cell-middle widget-listing-z-title-outer"><span class="blake-von-hauer-font-1 widget-listing-z-title"><?php echo wp_kses_post( get_the_title() ); ?></span></div>
                        </div>
                    </div>

                    <?php } ?>

                </div>
            </a>

			<?php endwhile;

			wp_reset_postdata();

			/* */

		}

		if( $viewall == 'true' ) { ?><a href="<?php echo esc_url( $viewall_url ); ?>"><div class="blake-von-hauer-font-3 fw700 fst-italic fs14 widget-view-all <?php echo esc_attr( 'cpw-' . $cpw_rand ); ?>"><?php echo esc_attr( $blake_von_hauer_tra_ViewAll ); ?></div></a><?php }

		echo wp_kses_post( $after_widget ); //Widget ends printing information

	}

}

/* blake_von_hauer_customCatsWidget Class */
class blake_von_hauer_customCatsWidget extends WP_Widget {

	function __construct() {
		parent::__construct(

			'blake_von_hauer_customCatsWidget',
			'Blake Widget: Tags/Categories',
			array( 'description' => "A well styled list of your tags or categories." )

		);
	}

	//Designing the widget, which will be displayed in the admin dashboard widget location.
	public function form( $instance ) {

		$defaults = array( 'name' => 'TAGS', 'tag_count' => '0', 'cat_count' => '0', 'show_tags' => 'on' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		?>

        <p><em>Uncheck "Show Tags" below to show categories.</em></p>
        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['show_tags'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'show_tags' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'show_tags' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'show_tags' ) ); ?>">Show Tags</label>
		</p>
		<p><strong>Title:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'name' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['name'] ); ?>" style="width: 100%;" /></p>
        <p><strong>Number of Tags to show:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'tag_count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['tag_count'] ); ?>" style="width: 50px;" /></p>
        <p><em>Write "0" to display all tags/categories.</em></p>
        <p><strong>Number of Categories to show:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'cat_count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['cat_count'] ); ?>" style="width: 50px;" /></p>

		<?php

	}

	// Update the new values in database
	function update( $new_instance, $old_instance ) {

		$instance = $old_instance;

		$instance['name'] = ( !empty( $new_instance['name'] ) ) ? strip_tags( $new_instance['name'] ) : 'TAGS';
		$instance['tag_count'] = $new_instance['tag_count'];
		$instance['cat_count'] = $new_instance['cat_count'];
		$instance['show_tags'] = $new_instance['show_tags'];

		return $instance;

	}

	//Display the stored widget information in webpage.
	function widget( $args, $instance ) {

		extract( $args );

		echo wp_kses_post( $before_widget ); //Widget starts to print information

		$defaults = array( 'name' => 'TAGS', 'tag_count' => '0', 'cat_count' => '0', 'show_tags' => 'on' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		$name = apply_filters( 'widget_title', $instance['name'] );
		$tag_count = $instance['tag_count'];
		$cat_count = $instance['cat_count'];
		$show_tags = $instance['show_tags'] ? 'true' : 'false';

		$taxonomy = '';
		$count = 0;

		if ( $show_tags == 'true' ) {

			$taxonomy = 'post_tag';
			$count = esc_attr( $tag_count );

		} else {

			$taxonomy = 'category';
			$count = esc_attr( $cat_count );

		}

		if ( !empty( $name ) ) {

			echo wp_kses_post( $before_title ) . esc_attr( $name ) . wp_kses_post( $after_title );

			/* function */

			$tag_args = array(

				'smallest'                  => 14,
				'largest'                   => 14,
				'unit'                      => 'px',
				'number'                    => $count,
				'format'                    => 'list',
				'taxonomy'                  => $taxonomy,

			);

			echo '<div class="blake-von-hauer-font-3 fw700 fst-italic clearfix">';
			wp_tag_cloud( $tag_args );
			echo '</div>';

			/* */

		}

		echo wp_kses_post( $after_widget ); //Widget ends printing information

	}

}

/* blake_von_hauer_customEmptySpaceWidget Class */
class blake_von_hauer_customEmptySpaceWidget extends WP_Widget {

	function __construct() {
		parent::__construct(

			'blake_von_hauer_customEmptySpaceWidget',
			'Blake Widget: Empty Space',
			array( 'description' => "Just place an empty space between your widgets if you wish. It's very handy!" )

		);
	}

	//Designing the widget, which will be displayed in the admin dashboard widget location.
	public function form( $instance ) {

		$defaults = array( 'count' => 20 );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		?>

        <p><strong>Height:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['count'] ); ?>" style="width: 50px;" /></p>

		<?php

	}

	// Update the new values in database
	function update( $new_instance, $old_instance ) {

		$instance = $old_instance;

		$instance['count'] = ( !empty( $new_instance['count'] ) ) ? strip_tags( $new_instance['count'] ) : '20';

		return $instance;

	}

	//Display the stored widget information in webpage.
	function widget( $args, $instance ) {

		extract( $args );

		if ( $id == 'blake_von_hauer_footer_widgets' ) {

			$fw_col_number = '';
			if ( get_theme_mod( 'blake_von_hauer_footerWidgetsCol', '3col' ) == '2col' ) { $fw_col_number = '-col2'; }
			echo '<div class="widget-item-footer-outer' . esc_attr( $fw_col_number ) . '">';

		} else if ( $id == 'blake_von_hauer_home_widgets' ) {

			$hw_col_number = '';
			if ( get_theme_mod( 'blake_von_hauer_homeWidgetsCol', '2col' ) == '2col' ) { $hw_col_number = '-col2'; }
			if ( get_theme_mod( 'blake_von_hauer_opt_Layout', '1col_sidebar' ) == '1col_sidebar' || get_theme_mod( 'blake_von_hauer_opt_Layout', '1col_sidebar' ) == '2col_sidebar' || get_theme_mod( 'blake_von_hauer_opt_Layout', '1col_sidebar' ) == '1_2col_sidebar' ) { $hw_col_number = '-col2-sidebar'; }
			echo '<div class="widget-item-home-outer' . esc_attr( $hw_col_number ) . '">';

		} else if ( $id == 'blake_von_hauer_upper_widgets' ) {

			$uw_col_number = '';
			if ( get_theme_mod( 'blake_von_hauer_upperWidgetsCol', '3col' ) == '2col' ) { $uw_col_number = '-col2'; }
			echo '<div class="widget-item-upper-outer' . esc_attr( $uw_col_number ) . '">';

		} else {

			echo '<div id="' . esc_attr( $this->id ) . '">';

		}

		$defaults = array( 'count' => 20 );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		$count = apply_filters( 'widget_title', $instance['count'] );

		if ( !empty( $count ) ) {

			/* function */

			?>

			<div style="height: <?php echo esc_attr( $count ); ?>px;"></div>

            <?php

			/* */

		}

		echo '</div>';

	}

}

/* blake_von_hauer_customFacebookFindUsWidget Class */
class blake_von_hauer_customFacebookFindUsWidget extends WP_Widget {

	function __construct() {
		parent::__construct(

			'blake_von_hauer_customFacebookFindUsWidget',
			'Blake Widget: Find us on Facebook',
			array( 'description' => "Show your Facebook page's lovers." )

		);
	}

	//Designing the widget, which will be displayed in the admin dashboard widget location.
	public function form( $instance ) {

		$defaults = array( 'page' => 'burnhambox', 'height' => '400', 'faces' => 'on', 'posts' => 'on' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		?>

		<p><strong>Facebook page username:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'page' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['page'] ); ?>" style="width: 100%;" /></p>
        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'height' ) ); ?>"><strong>Height</strong> <em>(min. 70)</em><strong>:</strong></label>
		<input id="<?php echo esc_attr( $this->get_field_id( 'height' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'height' ) ); ?>" size="3" value="<?php echo esc_attr( $instance['height'] ); ?>" style="width: 50px;" />
		</p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['faces'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'faces' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'faces' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'faces' ) ); ?>">Show Friend's Faces <em>("Height" value must be at least 215.)</em></label>
		</p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['posts'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'posts' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'posts' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'posts' ) ); ?>">Show Page Posts <em>("Height" value must be at least 300.)</em></label>
		</p>

		<?php

	}

	// Update the new values in database
	function update( $new_instance, $old_instance ) {

		$instance = $old_instance;

		$instance['page'] = ( !empty( $new_instance['page'] ) ) ? strip_tags( $new_instance['page'] ) : 'burnhambox';
		$instance['height'] = ( !empty( $new_instance['height'] ) ) ? strip_tags( $new_instance['height'] ) : '400';
		$instance['faces'] = $new_instance['faces'];
		$instance['posts'] = $new_instance['posts'];

		return $instance;

	}

	//Display the stored widget information in webpage.
	function widget( $args, $instance ) {

		global $id;

		extract( $args );

		if ( $id == 'blake_von_hauer_footer_widgets' ) {

			$fw_col_number = '';
			if ( get_theme_mod( 'blake_von_hauer_footerWidgetsCol', '3col' ) == '2col' ) { $fw_col_number = '-col2'; }
			echo '<div class="widget-item-footer-outer' . esc_attr( $fw_col_number ) . '">';

		} else if ( $id == 'blake_von_hauer_home_widgets' ) {

			$hw_col_number = '';
			if ( get_theme_mod( 'blake_von_hauer_homeWidgetsCol', '2col' ) == '2col' ) { $hw_col_number = '-col2'; }
			if ( get_theme_mod( 'blake_von_hauer_opt_Layout', '1col_sidebar' ) == '1col_sidebar' || get_theme_mod( 'blake_von_hauer_opt_Layout', '1col_sidebar' ) == '2col_sidebar' || get_theme_mod( 'blake_von_hauer_opt_Layout', '1col_sidebar' ) == '1_2col_sidebar' ) { $hw_col_number = '-col2-sidebar'; }
			echo '<div class="widget-item-home-outer' . esc_attr( $hw_col_number ) . '">';

		} else if ( $id == 'blake_von_hauer_upper_widgets' ) {

			$uw_col_number = '';
			if ( get_theme_mod( 'blake_von_hauer_upperWidgetsCol', '3col' ) == '2col' ) { $uw_col_number = '-col2'; }
			echo '<div class="widget-item-upper-outer' . esc_attr( $uw_col_number ) . '">';

		} else {

			echo '<div id="' . esc_attr( $this->id ) . '">';

		}

		$defaults = array( 'page' => 'burnhambox', 'height' => '400', 'faces' => 'on', 'posts' => 'on' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		$page = apply_filters( 'widget_title', $instance['page'] );
		$height = $instance['height'];
		$faces = $instance['faces'] ? 'true' : 'false';
		$posts = $instance['posts'] ? 'true' : 'false';

		if ( !empty( $page ) ) {

			/* function */

			?>

			<div id="fb-root"></div>
			<script>(function(d, s, id) {
              var js, fjs = d.getElementsByTagName(s)[0];
              if (d.getElementById(id)) return;
              js = d.createElement(s); js.id = id;
			  <?php
			  $facebook_sdk_language = '';
			  if ( get_theme_mod( 'blake_von_hauer_IgnorePOT', 0 ) && get_theme_mod( 'blake_von_hauer_tra_Lang' ) ) { $facebook_sdk_language = esc_attr( get_theme_mod( 'blake_von_hauer_tra_Lang' ) ); } else { $facebook_sdk_language = get_bloginfo( 'language' ); }
			  ?>
			  js.src = "//connect.facebook.net/" + "<?php echo str_replace( '-', '_', $facebook_sdk_language ); ?>" + "/sdk.js#xfbml=1&version=v2.4";
              fjs.parentNode.insertBefore(js, fjs);
            }(document, 'script', 'facebook-jssdk'));</script>

            <div class="fb-page" data-href="<?php echo esc_url( 'https://www.facebook.com/' . esc_attr( $page ) ); ?>" data-width="300" data-height="<?php echo esc_attr( $height ); ?>" data-small-header="false" data-adapt-container-width="true" data-hide-cover="false" data-show-facepile="<?php if ( $faces == 'true' ) { echo 'true'; } else { echo 'false'; } ?>" data-show-posts="<?php if ( $posts == 'true' ) { echo 'true'; } else { echo 'false'; } ?>"><div class="fb-xfbml-parse-ignore"></div></div>

            <?php

			/* */

		}

		echo '</div>';

	}

}

/* blake_von_hauer_customImageWidget Class */
class blake_von_hauer_customImageWidget extends WP_Widget {

	function __construct() {
		parent::__construct(

			'blake_von_hauer_customImageWidget',
			'Blake Widget: Image',
			array( 'description' => "Go ahead and place a nice image with a title and text. You can link it to anywhere too." )

		);
	}

	//Designing the widget, which will be displayed in the admin dashboard widget location.
	public function form( $instance ) {

		$defaults = array( 'name' => 'The Brand New Fashion Movie is On! Go and get it!', 'button' => '/ DISCOVER NOW /', 'path' => '', 'link' => '', 'target' => 'off', 'iwioi_color' => '#000', 'height' => '110', 'range' => '90' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		?>

        <script type='text/javascript'>

            jQuery( document ).ready( function($) {

				$('.iwioi-color-picker').wpColorPicker( {

		            defaultColor: '#000',
					change: _.throttle( function() { $('.iwioi-color-picker').trigger( 'change' ) }, 3000 ),

				} );

            } );

        </script>

        <p><strong>Image URL:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'path' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['path'] ); ?>" style="width: 100%;" /></p>
        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'iwioi_color' ) ); ?>"><strong>Use Color Instead of Image:</strong><br /><em>Only used if "Image URL" is blank.</em></label><br />
		<input class="iwioi-color-picker" type="text" id="<?php echo esc_attr( $this->get_field_id( 'iwioi_color' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'iwioi_color' ) ); ?>" value="<?php echo esc_attr( $instance['iwioi_color'] ); ?>" />
        </p>
        <p><strong>Height</strong> (<em>Only used if "Image URL" is blank</em>)<strong>:</strong>
		<input id="<?php echo esc_attr( $this->get_field_id( 'height' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'height' ) ); ?>" size="3" value="<?php echo esc_attr( $instance['height'] ); ?>" style="width: 50px;" />
		</p>

        <hr />

        <p><strong>Link:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'link' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['link'] ); ?>" style="width: 100%;" /></p>
        <p>
		<input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['target'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'target' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'target' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'target' ) ); ?>">Open in new window</label>
		</p>

        <hr />

		<p><strong>Title:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'name' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['name'] ); ?>" style="width: 100%;" /></p>
        <p><strong>Button:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'button' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['button'] ); ?>" style="width: 100%;" /></p>
        <p><strong>Lens Opacity:</strong><br />
        <input name="<?php echo esc_attr( $this->get_field_name( 'range' ) ); ?>" type="range" min="0" max="100" step="10" value="<?php echo esc_attr( $instance['range'] ); ?>" />
        </p>

		<?php

	}

	// Update the new values in database
	function update( $new_instance, $old_instance ) {

		$instance = $old_instance;

	    $instance['name'] = $new_instance['name'];
		$instance['button'] = $new_instance['button'];
		$instance['path'] = $new_instance['path'];
		$instance['link'] = $new_instance['link'];
		$instance['target'] = $new_instance['target'];
		$instance['iwioi_color'] = $new_instance['iwioi_color'];
		$instance['height'] = $new_instance['height'];
		$instance['range'] = $new_instance['range'];

		return $instance;

	}

	//Display the stored widget information in webpage.
	function widget( $args, $instance ) {

		extract( $args );

		/* Colors */
		$blake_von_hauer_color_White = get_theme_mod( 'blake_von_hauer_color_White', '#FFF' );
		/* */

		if ( $id == 'blake_von_hauer_footer_widgets' ) {

			$fw_col_number = '';
			if ( get_theme_mod( 'blake_von_hauer_footerWidgetsCol', '3col' ) == '2col' ) { $fw_col_number = '-col2'; }
			echo '<div class="widget-item-footer-outer' . esc_attr( $fw_col_number ) . '">';

		} else if ( $id == 'blake_von_hauer_home_widgets' ) {

			$hw_col_number = '';
			if ( get_theme_mod( 'blake_von_hauer_homeWidgetsCol', '2col' ) == '2col' ) { $hw_col_number = '-col2'; }
			if ( get_theme_mod( 'blake_von_hauer_opt_Layout', '1col_sidebar' ) == '1col_sidebar' || get_theme_mod( 'blake_von_hauer_opt_Layout', '1col_sidebar' ) == '2col_sidebar' || get_theme_mod( 'blake_von_hauer_opt_Layout', '1col_sidebar' ) == '1_2col_sidebar' ) { $hw_col_number = '-col2-sidebar'; }
			echo '<div class="widget-item-home-outer' . esc_attr( $hw_col_number ) . '">';

		} else if ( $id == 'blake_von_hauer_upper_widgets' ) {

			$uw_col_number = '';
			if ( get_theme_mod( 'blake_von_hauer_upperWidgetsCol', '3col' ) == '2col' ) { $uw_col_number = '-col2'; }
			echo '<div class="widget-item-upper-outer' . esc_attr( $uw_col_number ) . '">';

		} else {

			echo '<div id="' . esc_attr( $this->id ) . '" class="widget-item image-widget-wrapper-outer">';

		}

		$defaults = array( 'name' => 'The Brand New Fashion Movie is On! Go and get it!', 'button' => '/ DISCOVER NOW /', 'path' => '', 'link' => '', 'target' => 'off', 'iwioi_color' => '#000', 'height' => '110', 'range' => '90' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		$name = $instance['name'];
		$button = $instance['button'];
		$path = $instance['path'];
		$link = $instance['link'];
		$target = $instance['target'] ? 'true' : 'false';
		$iwioi_color = $instance['iwioi_color'];
		$height = $instance['height'];
		$range = $instance['range'];

		/* */

		$iw_rand = rand( 1, 9999999 ); ?>

        <style type="text/css" scoped>

			.image-widget-wrapper div.image-widget-content .image-widget-inner .image-widget-title<?php echo esc_attr( '.iw-' . $iw_rand ); ?> { background: rgba( <?php echo esc_attr( blake_von_hauer_hex2rgb( $blake_von_hauer_color_White ) ) . ',' . esc_attr( $range ) / 100 ?> ); -webkit-transition: all 0.3s ease-out; transition: all 0.3s ease-out; }
			.image-widget-wrapper a:hover > div.image-widget-content .image-widget-inner .image-widget-title<?php echo esc_attr( '.iw-' . $iw_rand ); ?> { background: rgba( <?php echo esc_attr( blake_von_hauer_hex2rgb( $blake_von_hauer_color_White ) ) ?>,1 ); }

		</style>

        <?php

		/* function */

		?>

        <div class="image-widget-wrapper clearfix"><?php if ( $link ) { echo '<a href="' . esc_attr( $link ) . '" target="'; if ( $target == 'true' ) { echo '_blank'; } else { echo '_self'; } echo '">'; } ?>

        <?php if ( $path ) { ?><img alt="image-widget-visual" src="<?php echo esc_attr( $path ); ?>" /><?php } ?>

        <?php if ( $name ) { ?>
            <div class="image-widget-content" <?php if ( !$path ) { echo 'style="background-color: ' . esc_attr( $iwioi_color ) . '; width: 100%;"'; } ?>>
                <div class="image-widget-inner" <?php if ( !$path ) { echo 'style="height: ' . esc_attr( $height ) . 'px;"'; } ?>>
                    <div class="table-cell-middle<?php echo esc_attr( ' iw-' . $iw_rand ); ?>">
                       	<div class="fs25 blake-von-hauer-font-1 image-widget-title<?php echo esc_attr( ' iw-' . $iw_rand ); ?>"><?php echo wp_kses_post( $name ); ?><div class="fs14 blake-von-hauer-font-3 fw700 fst-italic image-widget-button"><?php echo esc_attr( $button ); ?></div></div>
                    </div>
                </div>
            </div>
        <?php } ?>

        <?php if ( $link ) { echo '</a>'; } ?></div>

		<?php

		/* */

		echo '</div>';

	}

}

/* blake_von_hauer_customPopularPostsWidget */
class blake_von_hauer_customPopularPostsWidget extends WP_Widget {

	function __construct() {
		parent::__construct(

			'blake_von_hauer_customPopularPostsWidget',
			'Blake Widget: Popular Posts',
			array( 'description' => "Some posts are crowded ha? This widget will find and display them." )

		);
	}

	//Designing the widget, which will be displayed in the admin dashboard widget location.
	public function form( $instance ) {

		$defaults = array( 'name' => 'POPULAR POSTS', 'count' => 4, 'comment_based' => 'on', 'day_limit' => 'on', 'styleB_count' => 1, 'styleZ_count' => 3, 'date' => 'on', 'commenticon' => 'on' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		?>

		<p><strong>Title:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'name' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['name'] ); ?>" style="width: 100%;" /></p>

        <hr />

        <p><strong>Number of posts to show:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['count'] ); ?>" style="width: 50px;" /></p>

        <em>If the sum of Style B and Z is bigger than the number of posts to show, your settings will be ignored and all the posts will be shown in Style B.</em>

        <p>Post count for <strong>Style B</strong>: <input name="<?php echo esc_attr( $this->get_field_name( 'styleB_count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['styleB_count'] ); ?>" style="width: 50px;" /></p>
        <p>Post count for <strong>Style Z</strong>: <input name="<?php echo esc_attr( $this->get_field_name( 'styleZ_count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['styleZ_count'] ); ?>" style="width: 50px;" /></p>

        <em>If the sum of Style B and Z is smaller than the number of posts to show, Style B will take effect to complete the count.</em><p />

        <hr />

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['date'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'date' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'date' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'date' ) ); ?>">Display post date for <strong>Style B</strong></label>
		</p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['commenticon'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'commenticon' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'commenticon' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'commenticon' ) ); ?>">Display comment icon for <strong>Style B</strong></label>
		</p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['day_limit'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'day_limit' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'day_limit' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'day_limit' ) ); ?>">Include last 60 days only</label>
		</p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['comment_based'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'comment_based' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'comment_based' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'comment_based' ) ); ?>">Comment Based Popularity</label>
        <br><em>Uncheck for "View Based Popularity".</em>
		</p>

		<?php

	}

	// Update the new values in database
	function update( $new_instance, $old_instance ) {

		$instance = $old_instance;

		$instance['name'] = ( !empty( $new_instance['name'] ) ) ? strip_tags( $new_instance['name'] ) : 'POPULAR POSTS';
		$instance['count'] = ( !empty( $new_instance['count'] ) ) ? strip_tags( $new_instance['count'] ) : '4';
		$instance['styleB_count'] = $new_instance['styleB_count'];
		$instance['styleZ_count'] = $new_instance['styleZ_count'];
		$instance['date'] = $new_instance['date'];
		$instance['commenticon'] = $new_instance['commenticon'];
		$instance['day_limit'] = $new_instance['day_limit'];
		$instance['comment_based'] = $new_instance['comment_based'];

		return $instance;

	}

	// Limit to last 60 days
	function filter_where( $where = '' ) {

		$where .= " AND post_date > '" . date( 'Y-m-d', strtotime( '-' . 60 .' days' ) ) . "'";
		return $where;

	}

	//Display the stored widget information in webpage.
	function widget( $args, $instance ) {

		extract( $args );

		echo wp_kses_post( $before_widget ); //Widget starts to print information

		$defaults = array( 'name' => 'POPULAR POSTS', 'count' => 4, 'comment_based' => 'on', 'day_limit' => 'on', 'styleB_count' => 1, 'styleZ_count' => 3, 'date' => 'on', 'commenticon' => 'on' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		$name = apply_filters( 'widget_title', $instance['name'] );
		$count = $instance['count'];
		$styleB_count = $instance['styleB_count'];
		$styleZ_count = $instance['styleZ_count'];
		$date = $instance['date'] ? 'true' : 'false';
		$commenticon = $instance['commenticon'] ? 'true' : 'false';
		$day_limit = $instance['day_limit'] ? 'true' : 'false';
		$comment_based = $instance['comment_based'] ? 'true' : 'false';

		/* Combine Widget Listing Settings */

		$w_listing_style = 'b';
		$w_listingOrder = 0;

		if ( $styleB_count + $styleZ_count > $count ) {

			$styleB_count = $count;
			$styleZ_count = 0;

		}

		/* */

		$ppw_rand = rand( 1, 9999999 ); ?>

        <?php

		if ( !empty( $name ) ) {

			echo '<h2 class="blake-von-hauer-font-1 ' . esc_attr( 'ppw-' . $ppw_rand ) .'"><span>' . esc_attr( $name ) . wp_kses_post( $after_title );

			/* function */

			if ( $comment_based == 'true' ) {

				$loop_args = array(

					'posts_per_page' => esc_attr( $count ),
					'orderby' => 'comment_count',
					'ignore_sticky_posts' => 1

				);

			} else {

				$loop_args = array(

					'posts_per_page' => esc_attr( $count ),
					'orderby'   => 'meta_value_num',
					'meta_key'  => 'post_views_count',
					'ignore_sticky_posts' => 1

				);

			}

			if ( $day_limit == 'true' ) { add_filter( 'posts_where', array( $this, 'filter_where' ) ); }
			$loop = new WP_Query( $loop_args );
			if ( $day_limit == 'true' ) { remove_filter( 'posts_where', array( $this, 'filter_where' ) ); }

			while( $loop->have_posts() ) : $loop->the_post();

			//Combine Widget Listing Settings Styles

			$w_listingOrder ++;

			if ( $styleB_count > 0 && ( $w_listingOrder > $count - ( $styleB_count + $styleZ_count ) && $w_listingOrder <= $count - $styleZ_count ) ) {

				$w_listing_style = 'b';

			}

			if ( $styleZ_count > 0 && ( $w_listingOrder > $count - $styleZ_count && $w_listingOrder <= $count ) ) {

				$w_listing_style = 'z';

			} ?>

            <a class="blake-von-hauer-posts-widget <?php echo esc_attr( 'ppw-' . $ppw_rand ); ?>" href="<?php echo esc_url( get_the_permalink() ); ?>">
                <div class="mt20">

                    <?php if ( $w_listing_style == 'b' ) { ?>

                    <?php if ( has_post_thumbnail() ) { ?><div class="listing-img-outer"><?php the_post_thumbnail( 'blake-von-hauer-thumbnail-image' ); ?></div><?php } ?>
                    <div class="listing-box clearfix">
						<?php if ( $date == 'true' ) { ?><div class="blake-von-hauer-font-3 fw700 fst-italic listing-date"><?php echo get_the_date(); ?></div><?php } ?>
                        <div class="listing-title blake-von-hauer-font-1"><?php echo wp_kses_post( the_title() ); ?></div>
                        <?php if ( $commenticon == 'true' && comments_open() ) { ?><div class="blake-von-hauer-font-3 fw700 fst-italic listing-comment-w-o-date clearfix"><div class="listing-comment-icon"><i class="fa fa-comment"></i></div><div class="listing-comment-number"><?php comments_number( '0', '1', '%' ); ?></div></div><?php } ?>
                    </div>

					<?php } else if ( $w_listing_style == 'z' ) { ?>

					<div class="widget-listing-z clearfix">
						<?php if ( has_post_thumbnail() ) { ?><?php echo the_post_thumbnail( 'blake-von-hauer-small-thumbnail-image' ); ?><?php } ?>
                        <div class="widget-listing-z-info <?php if ( has_post_thumbnail() ) { echo 'widget-listing-z-info-with-t'; } ?>">
<div class="table-cell-middle widget-listing-z-title-outer"><span class="blake-von-hauer-font-1 widget-listing-z-title"><?php echo wp_kses_post( get_the_title() ); ?></span></div>
                        </div>
                    </div>

                    <?php } ?>

                </div>
            </a>

			<?php endwhile;

			wp_reset_postdata();

			/* */

		}

		echo wp_kses_post( $after_widget ); //Widget ends printing information

	}

}

/* blake_von_hauer_customPostWidget Class */
class blake_von_hauer_customPostWidget extends WP_Widget {

	function __construct() {
		parent::__construct(

			'blake_von_hauer_customPostWidget',
			'Blake Widget: Post',
			array( 'description' => "Maybe you want some special attention for one of your posts. Use this!" )

		);
	}

	//Designing the widget, which will be displayed in the admin dashboard widget location.
	public function form( $instance ) {

		$defaults = array( 'text_color' => '#FFF', 'background_color' => '#ea667f', 'range' => '50', 'post_1' => '0', 'post_1_alt' => '0', 'target' => 'off', 'path_C' => '', 'path_C_alt' => '', 'hide_widget' => 'off', 'sponsored' => '' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		?>

        <script type='text/javascript'>

            jQuery( document ).ready( function($) {

                $('.pw-bg-color-picker').wpColorPicker( {

		            defaultColor: '#ea667f',
					change: _.throttle( function() { $('.pw-bg-color-picker').trigger( 'change' ) }, 3000 ),

				} );

				$('.pw-t-color-picker').wpColorPicker( {

		            defaultColor: '#FFF',
					change: _.throttle( function() { $('.pw-t-color-picker').trigger( 'change' ) }, 3000 ),

				} );

            } );

        </script>

        <p><strong>Post ID:</strong> <input id="get-dropdown-val-1-p" name="<?php echo esc_attr( $this->get_field_name( 'post_1' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['post_1'] ); ?>" style="width: 50px;" /> <strong>Alternative Post ID:</strong> <input id="get-dropdown-val-1-alt-p" name="<?php echo esc_attr( $this->get_field_name( 'post_1_alt' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['post_1_alt'] ); ?>" style="width: 50px;" /></p>

        <p><em>To avoid duplicated posts, you can set an alternative post (Alternative Post ID) which will be shown instead of the original one (Post ID), on the original post page. Or simply hide the widget on the original post page by checking below.</em></p>

        <p>
		<input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['hide_widget'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'hide_widget' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'hide_widget' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'hide_widget' ) ); ?>">Hide widget on The Post Page</label>
		</p>

        <p>
		<input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['target'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'target' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'target' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'target' ) ); ?>">Open in new window</label>
		</p>

        <p><strong>Sponsored Text:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'sponsored' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['sponsored'] ); ?>" style="width: 100%;" /></p>

        <p><strong>Custom Image URLs:</strong><br /><em><br />Primary Post Image URL:</em><input name="<?php echo esc_attr( $this->get_field_name( 'path_C' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['path_C'] ); ?>" style="width: 100%;" /></p>

        <p><em>Alternative Post Image URL:</em><input name="<?php echo esc_attr( $this->get_field_name( 'path_C_alt' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['path_C_alt'] ); ?>" style="width: 100%;" /></p>

        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'background_color' ) ); ?>">Background Color:</label>
		<br />
		<input class="pw-bg-color-picker" type="text" id="<?php echo esc_attr( $this->get_field_id( 'background_color' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'background_color' ) ); ?>" value="<?php echo esc_attr( $instance['background_color'] ); ?>" />
        </p>

        <p>Lens Opacity:<br />
        <input name="<?php echo esc_attr( $this->get_field_name( 'range' ) ); ?>" type="range" min="0" max="100" step="10" value="<?php echo esc_attr( $instance['range'] ); ?>" />
        </p>

        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'text_color' ) ); ?>">Title Color:</label>
		<br />
		<input class="pw-t-color-picker" type="text" id="<?php echo esc_attr( $this->get_field_id( 'text_color' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'text_color' ) ); ?>" value="<?php echo esc_attr( $instance['text_color'] ); ?>" />
        </p>

		<?php

	}

	// Update the new values in database
	function update( $new_instance, $old_instance ) {

		$instance = $old_instance;

		$instance['text_color'] = $new_instance['text_color'];
		$instance['background_color'] = $new_instance['background_color'];
		$instance['range'] = $new_instance['range'];
		$instance['post_1'] = $new_instance['post_1'];
		$instance['post_1_alt'] = $new_instance['post_1_alt'];
		$instance['target'] = $new_instance['target'];
		$instance['path_C'] = $new_instance['path_C'];
		$instance['path_C_alt'] = $new_instance['path_C_alt'];
		$instance['hide_widget'] = $new_instance['hide_widget'];
		$instance['sponsored'] = $new_instance['sponsored'];

		return $instance;

	}

	//Display the stored widget information in webpage.
	function widget( $args, $instance ) {

		extract( $args );

		$defaults = array( 'text_color' => '#FFF', 'background_color' => '#ea667f', 'range' => '50', 'post_1' => '0', 'post_1_alt' => '0', 'target' => 'off', 'path_C' => '', 'path_C_alt' => '', 'hide_widget' => 'off', 'sponsored' => '' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		$text_color = $instance['text_color'];
		$background_color = $instance['background_color'];
		$range = $instance['range'];
		$post_1 = $instance['post_1'];
		$post_1_alt = $instance['post_1_alt'];
		$target = $instance['target'] ? 'true' : 'false';
		$path_C = $instance['path_C'];
		$path_C_alt = $instance['path_C_alt'];
		$hide_widget = $instance['hide_widget'] ? 'true' : 'false';
		$sponsored = $instance['sponsored'];

		$postid = get_the_ID();

		if ( $postid == $post_1 && $hide_widget == 'true' ) {

			// Hide the widget

		} else {

			// Place the widget

			if ( $id == 'blake_von_hauer_footer_widgets' ) {

				$fw_col_number = '';
				if ( get_theme_mod( 'blake_von_hauer_footerWidgetsCol', '3col' ) == '2col' ) { $fw_col_number = '-col2'; }
				echo '<div class="widget-item-footer-outer' . esc_attr( $fw_col_number ) . '">';

			} else if ( $id == 'blake_von_hauer_home_widgets' ) {

				$hw_col_number = '';
				if ( get_theme_mod( 'blake_von_hauer_homeWidgetsCol', '2col' ) == '2col' ) { $hw_col_number = '-col2'; }
				if ( get_theme_mod( 'blake_von_hauer_opt_Layout', '1col_sidebar' ) == '1col_sidebar' || get_theme_mod( 'blake_von_hauer_opt_Layout', '1col_sidebar' ) == '2col_sidebar' || get_theme_mod( 'blake_von_hauer_opt_Layout', '1col_sidebar' ) == '1_2col_sidebar' ) { $hw_col_number = '-col2-sidebar'; }
				echo '<div class="widget-item-home-outer' . esc_attr( $hw_col_number ) . '">';

			} else if ( $id == 'blake_von_hauer_upper_widgets' ) {

				$uw_col_number = '';
				if ( get_theme_mod( 'blake_von_hauer_upperWidgetsCol', '3col' ) == '2col' ) { $uw_col_number = '-col2'; }
				echo '<div class="widget-item-upper-outer' . esc_attr( $uw_col_number ) . '">';

			} else {

				echo '<div id="' . esc_attr( $this->id ) . '" class="widget-item">';

			}

			$w_selectedCount = 0;

			if ( $post_1 != 0 && $post_1 != 999999 ) { $w_selectedCount++; }

			/* */

			$pw_rand = rand( 1, 9999999 ); ?>

			<style type="text/css" scoped>
				<?php echo esc_attr( 'a.pw-' . $pw_rand ); ?> .image-widget-wrapper .table-cell-middle,
				<?php echo esc_attr( 'a.pw-' . $pw_rand . ':visited' ); ?> .image-widget-wrapper .table-cell-middle { background: rgba(<?php echo esc_attr( blake_von_hauer_hex2rgb( $background_color ) ); ?>,<?php echo esc_attr( $range ) / 100; ?> ); -webkit-transition: all 0.3s ease-out; transition: all 0.3s ease-out; }
				<?php echo esc_attr( 'a.pw-' . $pw_rand . ':hover' ); ?> .image-widget-wrapper .table-cell-middle { background: rgba(<?php echo esc_attr( blake_von_hauer_hex2rgb( $background_color ) ); ?>,0.9 ) }
				<?php echo esc_attr( 'a.pw-' . $pw_rand ); ?> .image-widget-wrapper .listing-title { color: <?php echo esc_attr( $text_color ); ?>; }

			</style>

			<?php

			if ( $w_selectedCount ) {

				/* function */

				if ( $postid == $post_1 && $post_1_alt != 0 && $post_1_alt != '' ) { $post_1 = $post_1_alt; $path_C = $path_C_alt; }

				$loop_args = array(

					'showposts' => 1,
					'post_type' => 'post',
					'post__in' => array( esc_attr( $post_1 ) ),
					'ignore_sticky_posts' => 1,
					'orderby' => 'post__in'

				);

				$rPosts = new WP_Query( $loop_args );

				while ( $rPosts->have_posts() ) : $rPosts->the_post(); ?>

					<a class="blake-von-hauer-post-widget <?php echo esc_attr( 'pw-' . $pw_rand ); ?>" href="<?php echo esc_url( get_the_permalink() ); ?>" target="<?php if ( $target == 'true' ) { echo '_blank'; } else { echo '_self'; } ?>">
						<div class="clearfix">
							<div class="image-widget-wrapper clearfix<?php if ( !has_post_thumbnail() ) { echo ' imw-w-o-i'; } ?>">
								<?php if ( has_post_thumbnail() && !$path_C ) { the_post_thumbnail(); } else if ( $path_C ) { echo '<img src="' . esc_url( $path_C ) . '" />'; } ?>
								<div class="image-widget-content">
									<div class="image-widget-inner">
										<div class="table-cell-middle">
											<div class="blake-von-hauer-font-1 listing-title"><?php the_title(); ?><?php if ( $sponsored ) { ?><div class="blake-von-hauer-font-3 sponsored-post"><?php echo esc_attr( $sponsored ); ?></div><?php } ?></div>
										</div>
									</div>
								</div>
							</div>
						</div>
					</a>

				<?php endwhile;

				wp_reset_postdata();

				/* */

			}

			echo '</div>';

		}

	}

}

/* blake_von_hauer_customRecentCommentsWidget Class */
class blake_von_hauer_customRecentCommentsWidget extends WP_Widget {

	function __construct() {
		parent::__construct(

			'blake_von_hauer_customRecentCommentsWidget',
			'Blake Widget: Recent Comments',
			array( 'description' => "Display the latest comments your visitors have dropped." )

		);
	}

	//Designing the widget, which will be displayed in the admin dashboard widget location.
	public function form( $instance ) {

		$defaults = array( 'name' => 'RECENT COMMENTS', 'count' => 3 );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		?>

		<p><strong>Title:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'name' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['name'] ); ?>" style="width: 100%;" /></p>
        <p><strong>Number of comments to show:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['count'] ); ?>" style="width: 50px;" /></p>

		<?php

	}

	// Update the new values in database
	function update( $new_instance, $old_instance ) {

		$instance = $old_instance;

		$instance['name'] = ( !empty( $new_instance['name'] ) ) ? strip_tags( $new_instance['name'] ) : 'RECENT COMMENTS';
		$instance['count'] = ( !empty( $new_instance['count'] ) ) ? strip_tags( $new_instance['count'] ) : '3';

		return $instance;

	}

	//Display the stored widget information in webpage.
	function widget( $args, $instance ) {

		extract( $args );

		echo wp_kses_post( $before_widget ); //Widget starts to print information

		$defaults = array( 'name' => 'RECENT COMMENTS', 'count' => 3 );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		echo '<div class="recent-comments">';

		$name = apply_filters( 'widget_title', $instance['name'] );
		$count = $instance['count'];

		if ( !empty( $name ) ) {

			echo wp_kses_post( $before_title ) . esc_attr( $name ) . wp_kses_post( $after_title );

			/* function */

			$approvedCounter = 0;

			$comments_query = new WP_Comment_Query();
			$comments = $comments_query->query( array( 'number' => 50 ) );

			if ( $comments ) {

				foreach( $comments as $comment ) {

					if ( $comment->comment_approved == '1' && $approvedCounter < $count && !post_password_required( $comment->comment_post_ID ) ) {

						$approvedCounter ++;

						$link = get_permalink( $comment->comment_post_ID ) . '#comment-' . esc_attr( $comment->comment_ID );
                        $title = get_the_title( $comment->comment_post_ID ); ?>

                        <div class="recent-comment-item clearfix">
                            <div class="recent-comment-img"><i class="fa fa-comment"></i></div>
                            <div class="recent-comment-hdr blake-von-hauer-font-1"><a href="<?php echo esc_url ( $link ); ?>"><?php echo wp_kses_post( $title ); ?></a></div>
                        </div>

					<?php }

				}

			}

			/* */

		}

		echo '</div>';

		echo wp_kses_post( $after_widget ); //Widget ends printing information

	}

}

/* blake_von_hauer_customRecentPostsWidget Class */
class blake_von_hauer_customRecentPostsWidget extends WP_Widget {

	function __construct() {
		parent::__construct(

			'blake_von_hauer_customRecentPostsWidget',
			'Blake Widget: Recent Posts',
			array( 'description' => "Display a couple or two of your latest posts." )

		);
	}

	//Designing the widget, which will be displayed in the admin dashboard widget location.
	public function form( $instance ) {

		$defaults = array( 'name' => 'RECENT POSTS', 'count' => 4, 'recent' => 'on', 'styleB_count' => 1, 'styleZ_count' => 3, 'date' => 'on', 'commenticon' => 'on' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		?>

		<p><strong>Title:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'name' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['name'] ); ?>" style="width: 100%;" /></p>

        <hr />

        <p><strong>Number of posts to show:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['count'] ); ?>" style="width: 50px;" /></p>

        <em>If the sum of Style B and Z is bigger than the number of posts to show, your settings will be ignored and all the posts will be shown in Style B.</em>

        <p>Post count for <strong>Style B</strong>: <input name="<?php echo esc_attr( $this->get_field_name( 'styleB_count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['styleB_count'] ); ?>" style="width: 50px;" /></p>
        <p>Post count for <strong>Style Z</strong>: <input name="<?php echo esc_attr( $this->get_field_name( 'styleZ_count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['styleZ_count'] ); ?>" style="width: 50px;" /></p>

        <em>If the sum of Style B and Z is smaller than the number of posts to show, Style B will take effect to complete the count.</em><p />

        <hr />

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['date'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'date' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'date' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'date' ) ); ?>">Display post date for <strong>Style B</strong></label>
		</p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['commenticon'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'commenticon' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'commenticon' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'commenticon' ) ); ?>">Display comment icon for <strong>Style B</strong></label>
		</p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['recent'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'recent' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'recent' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'recent' ) ); ?>">Recent Posts</label>
        <br><em>Uncheck for "Random Posts".</em>
		</p>

		<?php

	}

	// Update the new values in database
	function update( $new_instance, $old_instance ) {

		$instance = $old_instance;

		$instance['name'] = ( !empty( $new_instance['name'] ) ) ? strip_tags( $new_instance['name'] ) : 'RECENT POSTS';
		$instance['count'] = ( !empty( $new_instance['count'] ) ) ? strip_tags( $new_instance['count'] ) : '4';
		$instance['styleB_count'] = $new_instance['styleB_count'];
		$instance['styleZ_count'] = $new_instance['styleZ_count'];
		$instance['date'] = $new_instance['date'];
		$instance['commenticon'] = $new_instance['commenticon'];
		$instance['recent'] = $new_instance['recent'];

		return $instance;

	}

	//Display the stored widget information in webpage.
	function widget( $args, $instance ) {

		extract( $args );

		echo wp_kses_post( $before_widget ); //Widget starts to print information

		$defaults = array( 'name' => 'RECENT POSTS', 'count' => 4, 'recent' => 'on', 'styleB_count' => 1, 'styleZ_count' => 3, 'date' => 'on', 'commenticon' => 'on' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		$name = apply_filters( 'widget_title', $instance['name'] );
		$count = $instance['count'];
		$styleB_count = $instance['styleB_count'];
		$styleZ_count = $instance['styleZ_count'];
		$date = $instance['date'] ? 'true' : 'false';
		$commenticon = $instance['commenticon'] ? 'true' : 'false';
		$recent = $instance['recent'] ? 'true' : 'false';

		/* Combine Widget Listing Settings */

		$w_listing_style = 'b';
		$w_listingOrder = 0;

		if ( $styleB_count + $styleZ_count > $count ) {

			$styleB_count = $count;
			$styleZ_count = 0;

		}

		/* */

		$rpw_rand = rand( 1, 9999999 ); ?>

        <?php

		if ( !empty( $name ) ) {

			echo '<h2 class="blake-von-hauer-font-1 ' . esc_attr( 'rpw-' . $rpw_rand ) .'"><span>' . esc_attr( $name ) . wp_kses_post( $after_title );

			/* function */

			if ( $recent == 'true' ) {

				$loop_args = array(

					'showposts' => esc_attr( $count ),
					'ignore_sticky_posts' => 1

				);

			} else {

				$loop_args = array(

					'showposts' => esc_attr( $count ),
					'orderby' => 'rand',
					'ignore_sticky_posts' => 1

				);

			}

			$rPosts = new WP_Query( $loop_args );

			while ( $rPosts->have_posts() ) : $rPosts->the_post();

			//Combine Widget Listing Settings Styles

			$w_listingOrder ++;

			if ( $styleB_count > 0 && ( $w_listingOrder > $count - ( $styleB_count + $styleZ_count ) && $w_listingOrder <= $count - $styleZ_count ) ) {

				$w_listing_style = 'b';

			}

			if ( $styleZ_count > 0 && ( $w_listingOrder > $count - $styleZ_count && $w_listingOrder <= $count ) ) {

				$w_listing_style = 'z';

			} ?>

            <a class="blake-von-hauer-posts-widget <?php echo esc_attr( 'rpw-' . $rpw_rand ); ?>" href="<?php echo esc_url( get_the_permalink() ); ?>">
                <div class="mt20">

                    <?php if ( $w_listing_style == 'b' ) { ?>

                    <?php if ( has_post_thumbnail() ) { ?><div class="listing-img-outer"><?php the_post_thumbnail( 'blake-von-hauer-thumbnail-image' ); ?></div><?php } ?>
                    <div class="listing-box clearfix">
						<?php if ( $date == 'true' ) { ?><div class="blake-von-hauer-font-3 fw700 fst-italic listing-date"><?php echo get_the_date(); ?></div><?php } ?>
                        <div class="listing-title blake-von-hauer-font-1"><?php echo wp_kses_post( the_title() ); ?></div>
                        <?php if ( $commenticon == 'true' && comments_open() ) { ?><div class="blake-von-hauer-font-3 fw700 fst-italic listing-comment-w-o-date clearfix"><div class="listing-comment-icon"><i class="fa fa-comment"></i></div><div class="listing-comment-number"><?php comments_number( '0', '1', '%' ); ?></div></div><?php } ?>
                    </div>

					<?php } else if ( $w_listing_style == 'z' ) { ?>

					<div class="widget-listing-z clearfix">
						<?php if ( has_post_thumbnail() ) { ?><?php echo the_post_thumbnail( 'blake-von-hauer-small-thumbnail-image' ); ?><?php } ?>
                        <div class="widget-listing-z-info <?php if ( has_post_thumbnail() ) { echo 'widget-listing-z-info-with-t'; } ?>">
<div class="table-cell-middle widget-listing-z-title-outer"><span class="blake-von-hauer-font-1 widget-listing-z-title"><?php echo wp_kses_post( get_the_title() ); ?></span></div>
                        </div>
                    </div>

                    <?php } ?>

                </div>
            </a>

			<?php endwhile;

			wp_reset_postdata();

			/* */

		}

		echo wp_kses_post( $after_widget ); //Widget ends printing information

	}

}

/* blake_von_hauer_customSearchWidget Class */
class blake_von_hauer_customSearchWidget extends WP_Widget {

	function __construct() {
		parent::__construct(

			'blake_von_hauer_customSearchWidget',
			'Blake Widget: Search',
			array( 'description' => "You can search for anything on your site. Can you believe it? :)" )

		);
	}

	//Designing the widget, which will be displayed in the admin dashboard widget location.
	public function form( $instance ) {

		$instance = wp_parse_args( ( array ) $instance );

		?>

        <p>There are no options for this widget.</p>

		<?php

	}

	// Update the new values in database
	function update( $new_instance, $old_instance ) {

		$instance = $old_instance;
		return $instance;

	}

	//Display the stored widget information in webpage.
	function widget( $args, $instance ) {

		extract( $args );

		if ( $id == 'blake_von_hauer_footer_widgets' ) {

			$fw_col_number = '';
			if ( get_theme_mod( 'blake_von_hauer_footerWidgetsCol', '3col' ) == '2col' ) { $fw_col_number = '-col2'; }
			echo '<div class="widget-item-footer-outer' . esc_attr( $fw_col_number ) . '">';

		} else if ( $id == 'blake_von_hauer_home_widgets' ) {

			$hw_col_number = '';
			if ( get_theme_mod( 'blake_von_hauer_homeWidgetsCol', '2col' ) == '2col' ) { $hw_col_number = '-col2'; }
			if ( get_theme_mod( 'blake_von_hauer_opt_Layout', '1col_sidebar' ) == '1col_sidebar' || get_theme_mod( 'blake_von_hauer_opt_Layout', '1col_sidebar' ) == '2col_sidebar' || get_theme_mod( 'blake_von_hauer_opt_Layout', '1col_sidebar' ) == '1_2col_sidebar' ) { $hw_col_number = '-col2-sidebar'; }
			echo '<div class="widget-item-home-outer' . esc_attr( $hw_col_number ) . '">';

		} else if ( $id == 'blake_von_hauer_upper_widgets' ) {

			$uw_col_number = '';
			if ( get_theme_mod( 'blake_von_hauer_upperWidgetsCol', '3col' ) == '2col' ) { $uw_col_number = '-col2'; }
			echo '<div class="widget-item-upper-outer' . esc_attr( $uw_col_number ) . '">';

		} else {

			echo '<div id="' . esc_attr( $this->id ) . '" class="widget-item clearfix">'; //Widget starts to print information

		}

		$instance = wp_parse_args( ( array ) $instance );

		/* Translation */
		$blake_von_hauer_tra_TypeKeyword = esc_html__( 'TYPE KEYWORD TO SEARCH', 'blake-von-hauer' );

		if ( get_theme_mod( 'blake_von_hauer_IgnorePOT', 0 ) ) {

			$blake_von_hauer_tra_TypeKeyword = get_theme_mod( 'blake_von_hauer_tra_TypeKeyword', 'TYPE KEYWORD TO SEARCH' );

		}
		/* */

		/* function */ ?>

        <div class="clearfix search-widget">
	        <div class="clearfix search-widget-inner">
                <div class="search-widget-input-box">
                    <form role="search" method="get" id="searchform_custom" action="<?php echo esc_url( home_url( '/' ) ); ?>">
                        <input class="blake-von-hauer-font-3 fw700 fst-italic search-widget-input" type="text" value="<?php echo esc_attr( $blake_von_hauer_tra_TypeKeyword ); ?>" name="s" id="s_custom" />
                    </form>
                </div>
                <div class="fs18 search-widget-s-icon">
                    <div class="table-cell-middle pr20"><i class="fa fa-angle-right"></i></div>
                </div>
            </div>
        </div>

        <?php

		/* */

		echo '</div>'; //Widget ends printing information

	}

}

/* blake_von_hauer_customSelectedPostsWidget Class */
class blake_von_hauer_customSelectedPostsWidget extends WP_Widget {

	function __construct() {
		parent::__construct(

			'blake_von_hauer_customSelectedPostsWidget',
			'Blake Widget: Selected Posts',
			array( 'description' => "Display the posts you've selected. Very useful for the posts you want to put forward." )

		);
	}

	//Designing the widget, which will be displayed in the admin dashboard widget location.
	public function form( $instance ) {

		$defaults = array( 'name' => 'SELECTED POSTS', 'styleB_count' => 1, 'styleZ_count' => 4, 'date' => 'on', 'commenticon' => 'on', 'post_1' => '0', 'post_2' => '0', 'post_3' => '0', 'post_4' => '0', 'post_5' => '0' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		?>

        <p><strong>Title:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'name' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['name'] ); ?>" style="width: 100%;" /></p>

        <hr />

        <p><strong>Post 1 ID:</strong> <input id="get-dropdown-val-1" name="<?php echo esc_attr( $this->get_field_name( 'post_1' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['post_1'] ); ?>" style="width: 50px;" /></p>
        <p><strong>Post 2 ID:</strong> <input id="get-dropdown-val-2" name="<?php echo esc_attr( $this->get_field_name( 'post_2' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['post_2'] ); ?>" style="width: 50px;" /></p>
        <p><strong>Post 3 ID:</strong> <input id="get-dropdown-val-3" name="<?php echo esc_attr( $this->get_field_name( 'post_3' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['post_3'] ); ?>" style="width: 50px;" /></p>
        <p><strong>Post 4 ID:</strong> <input id="get-dropdown-val-4" name="<?php echo esc_attr( $this->get_field_name( 'post_4' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['post_4'] ); ?>" style="width: 50px;" /></p>
        <p><strong>Post 5 ID:</strong> <input id="get-dropdown-val-5" name="<?php echo esc_attr( $this->get_field_name( 'post_5' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['post_5'] ); ?>" style="width: 50px;" /></p>

        <em>If the sum of Style B and Z is bigger than the number of posts to show, your settings will be ignored and all the posts will be shown in Style B.</em>

        <p>Post count for <strong>Style B</strong>: <input name="<?php echo esc_attr( $this->get_field_name( 'styleB_count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['styleB_count'] ); ?>" style="width: 50px;" /></p>
        <p>Post count for <strong>Style Z</strong>: <input name="<?php echo esc_attr( $this->get_field_name( 'styleZ_count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['styleZ_count'] ); ?>" style="width: 50px;" /></p>

        <em>If the sum of Style B and Z is smaller than the number of posts to show, Style B will take effect to complete the count.</em><p />

        <hr />

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['date'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'date' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'date' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'date' ) ); ?>">Display post date for <strong>Style B</strong></label>
		</p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['commenticon'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'commenticon' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'commenticon' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'commenticon' ) ); ?>">Display comment icon for <strong>Style B</strong></label>
		</p>

		<?php

	}

	// Update the new values in database
	function update( $new_instance, $old_instance ) {

		$instance = $old_instance;

		$instance['name'] = ( !empty( $new_instance['name'] ) ) ? strip_tags( $new_instance['name'] ) : 'SELECTED POSTS';
		$instance['styleB_count'] = $new_instance['styleB_count'];
		$instance['styleZ_count'] = $new_instance['styleZ_count'];
		$instance['date'] = $new_instance['date'];
		$instance['commenticon'] = $new_instance['commenticon'];
		$instance['post_1'] = $new_instance['post_1'];
		$instance['post_2'] = $new_instance['post_2'];
		$instance['post_3'] = $new_instance['post_3'];
		$instance['post_4'] = $new_instance['post_4'];
		$instance['post_5'] = $new_instance['post_5'];

		return $instance;

	}

	//Display the stored widget information in webpage.
	function widget( $args, $instance ) {

		extract( $args );

		echo wp_kses_post( $before_widget ); //Widget starts to print information

		$defaults = array( 'name' => 'SELECTED POSTS', 'styleB_count' => 1, 'styleZ_count' => 4, 'date' => 'on', 'commenticon' => 'on', 'post_1' => '0', 'post_2' => '0', 'post_3' => '0', 'post_4' => '0', 'post_5' => '0' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		$name = apply_filters( 'widget_title', $instance['name'] );
		$styleB_count = $instance['styleB_count'];
		$styleZ_count = $instance['styleZ_count'];
		$date = $instance['date'] ? 'true' : 'false';
		$commenticon = $instance['commenticon'] ? 'true' : 'false';
		$post_1 = $instance['post_1'];
		$post_2 = $instance['post_2'];
		$post_3 = $instance['post_3'];
		$post_4 = $instance['post_4'];
		$post_5 = $instance['post_5'];

		/* Combine Widget Listing Settings */

		$w_listing_style = 'b';
		$w_listingOrder = 0;
		$w_selectedCount = 0;

		if ( $post_1 != 0 && $post_1 != 999999 ) { $w_selectedCount++; }
		if ( $post_2 != 0 && $post_2 != 999999 ) { $w_selectedCount++; }
		if ( $post_3 != 0 && $post_3 != 999999 ) { $w_selectedCount++; }
		if ( $post_4 != 0 && $post_4 != 999999 ) { $w_selectedCount++; }
		if ( $post_5 != 0 && $post_5 != 999999 ) { $w_selectedCount++; }

		if ( $styleB_count + $styleZ_count > $w_selectedCount ) {

			$styleB_count = $w_selectedCount;
			$styleZ_count = 0;

		}

		/* */

		$spw_rand = rand( 1, 9999999 ); ?>

        <?php

		if ( !empty( $name ) ) {

			echo '<h2 class="blake-von-hauer-font-1 ' . esc_attr( 'spw-' . $spw_rand ) .'"><span>' . esc_attr( $name ) . wp_kses_post( $after_title );

			/* function */

			$loop_args = array(

				'post_type' => 'post',
				'post__in' => array( esc_attr( $post_1 ), esc_attr( $post_2 ), esc_attr( $post_3 ), esc_attr( $post_4 ), esc_attr( $post_5 ) ),
				'ignore_sticky_posts' => 1,
				'orderby' => 'post__in'

			);

			$rPosts = new WP_Query( $loop_args );

			while ( $rPosts->have_posts() ) : $rPosts->the_post();

			//Combine Widget Listing Settings Styles

			$w_listingOrder ++;

			if ( $styleB_count > 0 && ( $w_listingOrder > $w_selectedCount - ( $styleB_count + $styleZ_count ) && $w_listingOrder <= $w_selectedCount - $styleZ_count ) ) {

				$w_listing_style = 'b';

			}

			if ( $styleZ_count > 0 && ( $w_listingOrder > $w_selectedCount - $styleZ_count && $w_listingOrder <= $w_selectedCount ) ) {

				$w_listing_style = 'z';

			} ?>

            <a class="blake-von-hauer-posts-widget <?php echo esc_attr( 'spw-' . $spw_rand ); ?>" href="<?php echo esc_url( get_the_permalink() ); ?>">
                <div class="mt20">

                    <?php if ( $w_listing_style == 'b' ) { ?>

                    <?php if ( has_post_thumbnail() ) { ?><div class="listing-img-outer"><?php the_post_thumbnail( 'blake-von-hauer-thumbnail-image' ); ?></div><?php } ?>
                    <div class="listing-box clearfix">
						<?php if ( $date == 'true' ) { ?><div class="blake-von-hauer-font-3 fw700 fst-italic listing-date"><?php echo get_the_date(); ?></div><?php } ?>
                        <div class="listing-title blake-von-hauer-font-1"><?php echo wp_kses_post( the_title() ); ?></div>
                        <?php if ( $commenticon == 'true' && comments_open() ) { ?><div class="blake-von-hauer-font-3 fw700 fst-italic listing-comment-w-o-date clearfix"><div class="listing-comment-icon"><i class="fa fa-comment"></i></div><div class="listing-comment-number"><?php comments_number( '0', '1', '%' ); ?></div></div><?php } ?>
                    </div>

					<?php } else if ( $w_listing_style == 'z' ) { ?>

					<div class="widget-listing-z clearfix">
						<?php if ( has_post_thumbnail() ) { ?><?php echo the_post_thumbnail( 'blake-von-hauer-small-thumbnail-image' ); ?><?php } ?>
                        <div class="widget-listing-z-info <?php if ( has_post_thumbnail() ) { echo 'widget-listing-z-info-with-t'; } ?>">
<div class="table-cell-middle widget-listing-z-title-outer"><span class="blake-von-hauer-font-1 widget-listing-z-title"><?php echo wp_kses_post( get_the_title() ); ?></span></div>
                        </div>
                    </div>

                    <?php } ?>

                </div>
            </a>

			<?php endwhile;

			wp_reset_postdata();

			/* */

		}

		echo wp_kses_post( $after_widget ); //Widget ends printing information

	}

}

/* blake_von_hauer_customSocialWidget Class */
class blake_von_hauer_customSocialWidget extends WP_Widget {

	function __construct() {
		parent::__construct(

			'blake_von_hauer_customSocialWidget',
			'Blake Widget: Social',
			array( 'description' => "Place your social account icons in a sleek list." )

		);
	}

	//Designing the widget, which will be displayed in the admin dashboard widget location.
	public function form( $instance ) {

		$defaults = array( 'name' => 'SOCIAL NETWORK', 'facebook' => 'http://', 'twitter' => 'http://', 'instagram' => 'http://', 'pinterest' => 'http://', 'google' => 'http://', 'tumblr' => 'http://', 'flickr' => 'http://', 'digg' => 'http://', 'linkedin' => 'http://', 'vimeo' => 'http://', 'youtube' => 'http://', 'behance' => 'http://', 'dribble' => 'http://', 'deviantart' => 'http://', 'github' => 'http://', 'bloglovin' => 'http://', 'lastfm' => 'http://', 'soundcloud' => 'http://', 'vk' => 'http://' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		?>

		<p><strong>Title:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'name' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['name'] ); ?>" style="width: 100%;" /></p>
        <p><em>Write the entire URL addresses. Leave blank if not preferred.</em></p>
        <p><strong>Facebook:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'facebook' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['facebook'] ); ?>" style="width: 100%;" />
        <p><strong>Twitter:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'twitter' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['twitter'] ); ?>" style="width: 100%;" />
        <p><strong>Instagram:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'instagram' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['instagram'] ); ?>" style="width: 100%;" />
        <p><strong>Pinterest:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'pinterest' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['pinterest'] ); ?>" style="width: 100%;" />
        <p><strong>Google+:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'google' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['google'] ); ?>" style="width: 100%;" />
        <p><strong>Tumblr:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'tumblr' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['tumblr'] ); ?>" style="width: 100%;" />
        <p><strong>Flickr:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'flickr' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['flickr'] ); ?>" style="width: 100%;" />
        <p><strong>Digg:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'digg' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['digg'] ); ?>" style="width: 100%;" />
        <p><strong>LinkedIn:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'linkedin' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['linkedin'] ); ?>" style="width: 100%;" />
        <p><strong>Vimeo:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'vimeo' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['vimeo'] ); ?>" style="width: 100%;" />
        <p><strong>YouTube:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'youtube' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['youtube'] ); ?>" style="width: 100%;" />
        <p><strong>Behance:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'behance' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['behance'] ); ?>" style="width: 100%;" />
        <p><strong>Dribbble:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'dribble' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['dribble'] ); ?>" style="width: 100%;" />
        <p><strong>DeviantArt:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'deviantart' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['deviantart'] ); ?>" style="width: 100%;" />
        <p><strong>Github:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'github' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['github'] ); ?>" style="width: 100%;" />
        <p><strong>Bloglovin:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'bloglovin' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['bloglovin'] ); ?>" style="width: 100%;" />
        <p><strong>Lastfm:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'lastfm' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['lastfm'] ); ?>" style="width: 100%;" />
        <p><strong>SoundCloud:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'soundcloud' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['soundcloud'] ); ?>" style="width: 100%;" />
        <p><strong>VK:</strong> <input name="<?php echo esc_attr( $this->get_field_name( 'vk' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['vk'] ); ?>" style="width: 100%;" />

		<?php

	}

	// Update the new values in database
	function update( $new_instance, $old_instance ) {

		$instance = $old_instance;

		$instance['name'] = ( !empty( $new_instance['name'] ) ) ? strip_tags( $new_instance['name'] ) : 'SOCIAL NETWORK';
		$instance['facebook'] = ( !empty( $new_instance['facebook'] ) ) ? strip_tags( $new_instance['facebook'] ) : 'http://';
		$instance['twitter'] = ( !empty( $new_instance['twitter'] ) ) ? strip_tags( $new_instance['twitter'] ) : 'http://';
		$instance['instagram'] = ( !empty( $new_instance['instagram'] ) ) ? strip_tags( $new_instance['instagram'] ) : 'http://';
		$instance['pinterest'] = ( !empty( $new_instance['pinterest'] ) ) ? strip_tags( $new_instance['pinterest'] ) : 'http://';
		$instance['google'] = ( !empty( $new_instance['google'] ) ) ? strip_tags( $new_instance['google'] ) : 'http://';
		$instance['tumblr'] = ( !empty( $new_instance['tumblr'] ) ) ? strip_tags( $new_instance['tumblr'] ) : 'http://';
		$instance['flickr'] = ( !empty( $new_instance['flickr'] ) ) ? strip_tags( $new_instance['flickr'] ) : 'http://';
		$instance['digg'] = ( !empty( $new_instance['digg'] ) ) ? strip_tags( $new_instance['digg'] ) : 'http://';
		$instance['linkedin'] = ( !empty( $new_instance['linkedin'] ) ) ? strip_tags( $new_instance['linkedin'] ) : 'http://';
		$instance['vimeo'] = ( !empty( $new_instance['vimeo'] ) ) ? strip_tags( $new_instance['vimeo'] ) : 'http://';
		$instance['youtube'] = ( !empty( $new_instance['youtube'] ) ) ? strip_tags( $new_instance['youtube'] ) : 'http://';
		$instance['behance'] = ( !empty( $new_instance['behance'] ) ) ? strip_tags( $new_instance['behance'] ) : 'http://';
		$instance['dribble'] = ( !empty( $new_instance['dribble'] ) ) ? strip_tags( $new_instance['dribble'] ) : 'http://';
		$instance['deviantart'] = ( !empty( $new_instance['deviantart'] ) ) ? strip_tags( $new_instance['deviantart'] ) : 'http://';
		$instance['github'] = ( !empty( $new_instance['github'] ) ) ? strip_tags( $new_instance['github'] ) : 'http://';
		$instance['bloglovin'] = ( !empty( $new_instance['bloglovin'] ) ) ? strip_tags( $new_instance['bloglovin'] ) : 'http://';
		$instance['lastfm'] = ( !empty( $new_instance['lastfm'] ) ) ? strip_tags( $new_instance['lastfm'] ) : 'http://';
		$instance['soundcloud'] = ( !empty( $new_instance['soundcloud'] ) ) ? strip_tags( $new_instance['soundcloud'] ) : 'http://';
		$instance['vk'] = ( !empty( $new_instance['vk'] ) ) ? strip_tags( $new_instance['vk'] ) : 'http://';

		return $instance;

	}

	//Display the stored widget information in webpage.
	function widget( $args, $instance ) {

		extract( $args );

		echo wp_kses_post( $before_widget ); //Widget starts to print information

		$defaults = array( 'name' => 'SOCIAL NETWORK', 'facebook' => 'http://', 'twitter' => 'http://', 'instagram' => 'http://', 'pinterest' => 'http://', 'google' => 'http://', 'tumblr' => 'http://', 'flickr' => 'http://', 'digg' => 'http://', 'linkedin' => 'http://', 'vimeo' => 'http://', 'youtube' => 'http://', 'behance' => 'http://', 'dribble' => 'http://', 'deviantart' => 'http://', 'github' => 'http://', 'bloglovin' => 'http://', 'lastfm' => 'http://', 'soundcloud' => 'http://', 'vk' => 'http://' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		$name = apply_filters( 'widget_title', $instance['name'] );
		$facebook = $instance['facebook'];
		$twitter = $instance['twitter'];
		$instagram = $instance['instagram'];
		$pinterest = $instance['pinterest'];
		$google = $instance['google'];
		$tumblr = $instance['tumblr'];
		$flickr = $instance['flickr'];
		$digg = $instance['digg'];
		$linkedin = $instance['linkedin'];
		$vimeo = $instance['vimeo'];
		$youtube = $instance['youtube'];
		$behance = $instance['behance'];
		$dribble = $instance['dribble'];
		$deviantart = $instance['deviantart'];
		$github = $instance['github'];
		$bloglovin = $instance['bloglovin'];
		$lastfm = $instance['lastfm'];
		$soundcloud = $instance['soundcloud'];
		$vk = $instance['vk'];

		$social_accounts = array( $facebook, $twitter, $instagram, $pinterest, $google, $tumblr, $flickr, $digg, $linkedin, $vimeo, $youtube, $behance, $dribble, $deviantart, $github, $bloglovin, $lastfm, $soundcloud, $vk );

		$social_faIcons = array(
			'fa-facebook',
			'fa-twitter',
			'fa-instagram',
			'fa-pinterest-p',
			'fa-google-plus',
			'fa-tumblr',
			'fa-flickr',
			'fa-digg',
			'fa-linkedin',
			'fa-vimeo',
			'fa-youtube',
			'fa-behance',
			'fa-dribbble',
			'fa-deviantart',
			'fa-github',
			'fa-heart',
			'fa-lastfm',
			'fa-soundcloud',
			'fa-vk'
		);

		/* */

		?>

        <?php

		if ( !empty( $name ) ) {

			echo wp_kses_post( $before_title ) . esc_attr( $name ) . wp_kses_post( $after_title );

			/* function */

			echo '<div class="social-widget-outer"><ul class="social-widget clearfix">';

			foreach ( $social_accounts as $key => $sa ) {

				if ( $sa != 'http://' && $sa != '' ) {

					echo '<li><a class="social-widget-button clearfix" href="' . esc_url( $sa ) . '" target="_blank"><i class="fa ' . esc_attr( $social_faIcons[ $key ] ) . '"></i></a></li>';

				}

			}

			echo '</ul></div>';

			/* */

		}

		echo wp_kses_post( $after_widget ); //Widget ends printing information

	}

}

if ( !function_exists( 'blake_von_hauer_widgets_register' ) ) {
	function blake_von_hauer_widgets_register() {

		// Register Widgets
		if ( class_exists( 'blake_von_hauer_customAdWidget' ) ) { register_widget( 'blake_von_hauer_customAdWidget' ); }
		if ( class_exists( 'blake_von_hauer_customCatsWidget' ) ) { register_widget( 'blake_von_hauer_customCatsWidget' ); }
		if ( class_exists( 'blake_von_hauer_customSearchWidget' ) ) { register_widget( 'blake_von_hauer_customSearchWidget' ); }
		if ( class_exists( 'blake_von_hauer_customSocialWidget' ) ) { register_widget( 'blake_von_hauer_customSocialWidget' ); }
		if ( class_exists( 'blake_von_hauer_customImageWidget' ) ) { register_widget( 'blake_von_hauer_customImageWidget' ); }
		if ( class_exists( 'blake_von_hauer_customEmptySpaceWidget' ) ) { register_widget( 'blake_von_hauer_customEmptySpaceWidget' ); }
		if ( class_exists( 'blake_von_hauer_customRecentCommentsWidget' ) ) { register_widget( 'blake_von_hauer_customRecentCommentsWidget' ); }
		if ( class_exists( 'blake_von_hauer_customFacebookFindUsWidget' ) ) { register_widget( 'blake_von_hauer_customFacebookFindUsWidget' ); }
		if ( class_exists( 'blake_von_hauer_customPostWidget' ) ) { register_widget( 'blake_von_hauer_customPostWidget' ); }
		if ( class_exists( 'blake_von_hauer_customRecentPostsWidget' ) ) { register_widget( 'blake_von_hauer_customRecentPostsWidget' ); }
		if ( class_exists( 'blake_von_hauer_customPopularPostsWidget' ) ) { register_widget( 'blake_von_hauer_customPopularPostsWidget' ); }
		if ( class_exists( 'blake_von_hauer_customSelectedPostsWidget' ) ) { register_widget( 'blake_von_hauer_customSelectedPostsWidget' ); }
		if ( class_exists( 'blake_von_hauer_customCatPostsWidget' ) ) { register_widget( 'blake_von_hauer_customCatPostsWidget' ); }

	}
}
add_action( 'widgets_init', 'blake_von_hauer_widgets_register' );

/* Hit Counter */
if ( !function_exists( 'blake_von_hauer_getPostViews' ) ) {
	function blake_von_hauer_getPostViews( $postID ) {

		$count_key = 'post_views_count';
		$count = get_post_meta( $postID, $count_key, true );

		if ( $count == '' ) {

			delete_post_meta( $postID, $count_key );
			add_post_meta( $postID, $count_key, '0' );
			return '0';

		}

		return $count;

	}
}

if ( !function_exists( 'blake_von_hauer_setPostViews' ) ) {
	function blake_von_hauer_setPostViews( $postID ) {

		$count_key = 'post_views_count';
		$count = get_post_meta( $postID, $count_key, true );

		if ( $count == '' ) {

			$count = 0;
			delete_post_meta( $postID, $count_key );
			add_post_meta( $postID, $count_key, '0' );

		} else {

			$count ++;
			update_post_meta( $postID, $count_key, $count );

		}

	}
}
/* */

/* Call-to-Action Lines */

if ( !function_exists( 'blake_von_hauer_cta_lines' ) ) {
  function blake_von_hauer_cta_lines() {

    /* Translation */
    $blake_von_hauer_tra_DontMiss = esc_html__( 'DON\'T MISS THIS ONE:', 'blake-von-hauer' );

    if ( get_theme_mod( 'blake_von_hauer_IgnorePOT', 0 ) ) {

    	$blake_von_hauer_tra_DontMiss = get_theme_mod( 'blake_von_hauer_tra_DontMiss', 'DON\'T MISS THIS ONE:' );

    }
    /* */

    $authorized_term = get_theme_mod( 'blake_von_hauer_opt_APBase', 'author' );
    $authorized_type = get_theme_mod( 'blake_von_hauer_opt_APType', 'rand' );
    global $post;
    $blake_von_hauer_orig_post_auth = $post;
    $blake_von_hauer_tags_auth = wp_get_post_tags( $post->ID );
    $blake_von_hauer_cats_auth = wp_get_post_categories( $post->ID );
    $author_id = get_the_author_meta( 'ID' );
    $blake_von_hauer_RPBaseTermIDs_auth = '';

    if ( $authorized_term == 'tag' ) { $blake_von_hauer_RPBaseTermIDs_auth = $blake_von_hauer_tags_auth; } else if ( $authorized_term == 'category' ) { $blake_von_hauer_RPBaseTermIDs_auth = $blake_von_hauer_cats_auth; }

    if ( ( $blake_von_hauer_RPBaseTermIDs_auth || $authorized_term == 'author' ) && ( ( get_post_format() == 'gallery' && get_theme_mod( 'blake_von_hauer_sh_AuthorizedPosts_Gallery', 1 ) ) || ( get_post_format() == 'video' && get_theme_mod( 'blake_von_hauer_sh_AuthorizedPosts_Video', 1 ) ) || ( get_post_format() == '' && get_theme_mod( 'blake_von_hauer_sh_AuthorizedPosts', 1 ) ) ) ) {

    	if ( $authorized_term == 'tag' ) {

    		$blake_von_hauer_tag_ids_auth = array();
    		foreach ( $blake_von_hauer_tags_auth as $blake_von_hauer_individual_tag_auth ) { $blake_von_hauer_tag_ids_auth[] = $blake_von_hauer_individual_tag_auth->term_id; }

    		$args_auth = array(
    			'tag__in' => $blake_von_hauer_tag_ids_auth,
    			'post__not_in' => array( $post->ID ),
    			'orderby' => $authorized_type,
    			'posts_per_page' => 1, // Number of authorized posts to display.
    			'ignore_sticky_posts' => 1

    		);

    	} else if ( $authorized_term == 'category' ) {

    		$blake_von_hauer_cat_ids_auth = array();
    		foreach ( $blake_von_hauer_cats_auth as $blake_von_hauer_individual_cat_auth ) { $cat_auth = get_category( $blake_von_hauer_individual_cat_auth ); $blake_von_hauer_cat_ids_auth[] = $cat_auth->term_id; }

    		$args_auth = array(
    			'category__in' => $blake_von_hauer_cat_ids_auth,
    			'post__not_in' => array( $post->ID ),
    			'orderby' => $authorized_type,
    			'posts_per_page' => 1, // Number of authorized posts to display.
    			'ignore_sticky_posts' => 1

    		);

    	} else if ( $authorized_term == 'author' ) {

    		$args_auth = array(
    			'author' => $author_id,
    			'post__not_in' => array( $post->ID ),
    			'orderby' => $authorized_type,
    			'posts_per_page' => 1, // Number of authorized posts to display.
    			'ignore_sticky_posts' => 1

    		);

    	}

    	$blake_von_hauer_my_query_auth = new wp_query( $args_auth );

    	if ( $blake_von_hauer_my_query_auth->have_posts() ) {

    		while( $blake_von_hauer_my_query_auth->have_posts() ) {
                $blake_von_hauer_my_query_auth->the_post(); ?>

            	<p class="authorized-line blake-von-hauer-font-3 fs14 fw700 fst-italic"><?php echo esc_attr( $blake_von_hauer_tra_DontMiss ); ?> <a href="<?php esc_url( the_permalink() ); ?>"><?php the_title(); ?></a></p>

            <?php }

            $post = $blake_von_hauer_orig_post_auth;
            wp_reset_postdata();

    	}

    }

  }
}

/* */

/* Banner Management System - Leaderboard Banners */
if ( !function_exists( 'blake_von_hauer_banner_positions' ) ) {
	function blake_von_hauer_banner_positions() {

		$positions = [
			'hidden',
			'below-header',
			'above-upper-widgets',
			'below-upper-widgets',
			'above-blog-posts',
			'after-first-post',
			'below-blog-posts',
			'below-home-widgets',
			'above-post',
			'below-post',
			'below-post-comments',
			'above-page',
			'below-page',
			'below-page-comments',
		];

		return $positions;

	}
}

if ( !function_exists( 'blake_von_hauer_detectLeaderboard' ) ) {
	function blake_von_hauer_detectLeaderboard( $current_position ) {

		$blake_von_hauer_b1 = get_theme_mod( 'blake_von_hauer_opt_BannerPos_1', 'below-header' );
		$blake_von_hauer_b2 = get_theme_mod( 'blake_von_hauer_opt_BannerPos_2', 'below-upper-widgets' );
		$blake_von_hauer_b3 = get_theme_mod( 'blake_von_hauer_opt_BannerPos_3', 'after-first-post' );
		$blake_von_hauer_b4 = get_theme_mod( 'blake_von_hauer_opt_BannerPos_4', 'below-blog-posts' );
		$blake_von_hauer_b5 = get_theme_mod( 'blake_von_hauer_opt_BannerPos_5', 'below-post' );

		if ( $blake_von_hauer_b1 == $current_position ) { blake_von_hauer_callLeaderboard( 'blake_von_hauer_opt_BannerPos_1', 'below-header', 'blake_von_hauer_text_Banner_1', 'blake_von_hauer_sh_Banner_1_Archive', 'blake_von_hauer_sh_Banner_1_Post', 'blake_von_hauer_opt_ResponsiveBanner_1', $current_position ); }

		if ( $blake_von_hauer_b2 == $current_position ) { blake_von_hauer_callLeaderboard( 'blake_von_hauer_opt_BannerPos_2', 'below-upper-widgets', 'blake_von_hauer_text_Banner_2', 'blake_von_hauer_sh_Banner_2_Archive', 'blake_von_hauer_sh_Banner_2_Post', 'blake_von_hauer_opt_ResponsiveBanner_2', $current_position ); }

		if ( $blake_von_hauer_b3 == $current_position ) { blake_von_hauer_callLeaderboard( 'blake_von_hauer_opt_BannerPos_3', 'after-first-post', 'blake_von_hauer_text_Banner_3', 'blake_von_hauer_sh_Banner_3_Archive', 'blake_von_hauer_sh_Banner_3_Post', 'blake_von_hauer_opt_ResponsiveBanner_3', $current_position ); }

		if ( $blake_von_hauer_b4 == $current_position ) { blake_von_hauer_callLeaderboard( 'blake_von_hauer_opt_BannerPos_4', 'below-blog-posts', 'blake_von_hauer_text_Banner_4', 'blake_von_hauer_sh_Banner_4_Archive', 'blake_von_hauer_sh_Banner_4_Post', 'blake_von_hauer_opt_ResponsiveBanner_4', $current_position ); }

		if ( $blake_von_hauer_b5 == $current_position ) { blake_von_hauer_callLeaderboard( 'blake_von_hauer_opt_BannerPos_5', 'below-post', 'blake_von_hauer_text_Banner_5', 'blake_von_hauer_sh_Banner_5_Archive', 'blake_von_hauer_sh_Banner_5_Post', 'blake_von_hauer_opt_ResponsiveBanner_5', $current_position ); }

	}
}

if ( !function_exists( 'blake_von_hauer_callLeaderboard' ) ) {
	function blake_von_hauer_callLeaderboard( $banner, $default_position, $code, $show_archive, $show_post, $responsive, $current_position ) {

		$marginTop = '';

		if ( $current_position == 'below-post-comments' || $current_position == 'below-page-comments' ) { $marginTop = ' leaderboard-outer-pp-bottom'; }
		if ( $current_position == 'below-header' ) { $marginTop = ' leaderboard-outer-afs'; }

		$banner_output = '<div class="blake-von-hauer-font-2' . esc_attr( $marginTop ) . ' leaderboard-outer';

		if ( get_theme_mod( $responsive, 'static' ) == 'responsive' ) { $banner_output .= ' leaderboard-responsive'; } else { $banner_output .= ' leaderboard-static'; }

		if ( get_theme_mod( $banner, $default_position ) == 'below-header' || get_theme_mod( $banner, $default_position ) == 'above-upper-widgets' || get_theme_mod( $banner, $default_position ) == 'below-upper-widgets' ) {

			$banner_output .= ' leaderboard-full';

		} else {

			if ( is_category() || is_author() || is_tag() || is_archive() || is_search() ) {

				if ( get_theme_mod( 'blake_von_hauer_opt_Layout_Archive', '1col_sidebar' ) == '1col_sidebar' || get_theme_mod( 'blake_von_hauer_opt_Layout_Archive', '1col_sidebar' ) == '2col_sidebar' || get_theme_mod( 'blake_von_hauer_opt_Layout_Archive', '1col_sidebar' ) == '1_2col_sidebar' ) {

					$banner_output .= ' leaderboard-among';

				} else {

					$banner_output .= ' leaderboard-full';

				}

			} else if ( is_page() ) {

				if ( is_front_page() ) {

					if ( get_theme_mod( 'blake_von_hauer_sh_SidebarInnerStatic', 1 ) ) {

						$banner_output .= ' leaderboard-among';

					} else {

						$banner_output .= ' leaderboard-full';

					}

				} else {

					if ( get_theme_mod( 'blake_von_hauer_sh_SidebarInnerPage', 1 ) ) {

						$banner_output .= ' leaderboard-among';

					} else {

						$banner_output .= ' leaderboard-full';

					}

				}

			} else if ( is_single() ) {

				if ( !is_attachment() ) {

					$meta_sidebar = get_post_meta( get_the_ID(), 'bvh-sidebar-meta-box-checkbox', true );

					if ( ( get_post_format() == '' ) && get_theme_mod( 'blake_von_hauer_sh_SidebarPost_Standard', 1 ) && !$meta_sidebar ) {

						$banner_output .= ' leaderboard-among';

					} else if ( get_post_format() == 'gallery' && get_theme_mod( 'blake_von_hauer_sh_SidebarPost_Gallery', 1 ) && !$meta_sidebar ) {

						$banner_output .= ' leaderboard-among';

					} else if ( get_post_format() == 'video' && get_theme_mod( 'blake_von_hauer_sh_SidebarPost_Video', 1 ) && !$meta_sidebar ) {

						$banner_output .= ' leaderboard-among';

					} else {

						$banner_output .= ' leaderboard-full';

					}

				} else {

					$banner_output .= ' leaderboard-full';

				}

			} else {

				if ( get_theme_mod( 'blake_von_hauer_opt_Layout', '1col_sidebar' ) == '1col_sidebar' || get_theme_mod( 'blake_von_hauer_opt_Layout', '1col_sidebar' ) == '2col_sidebar' || get_theme_mod( 'blake_von_hauer_opt_Layout', '1col_sidebar' ) == '1_2col_sidebar' ) {

					$banner_output .= ' leaderboard-among';

				} else {

					$banner_output .= ' leaderboard-full';

				}

			}

		}

		$banner_output .= '"><div class="leaderboard-inner';

		$ad_code = apply_filters( 'widget_text', get_theme_mod( $code, '' ) );
		$banner_output .= '">' . wp_kses_post( $ad_code ) . '</div></div>';

		if ( get_theme_mod( $code, '' ) ) {

			if ( get_theme_mod( $banner, $default_position ) == 'below-header' || get_theme_mod( $banner, $default_position ) == 'above-upper-widgets' || get_theme_mod( $banner, $default_position ) == 'below-upper-widgets' ) {

				if ( is_home() || is_page() ) { echo wp_kses_post( $banner_output ); }
				if ( is_archive() && get_theme_mod( $show_archive, 0 ) ) { echo wp_kses_post( $banner_output ); }
				if ( is_single() && get_theme_mod( $show_post, 0 ) ) { echo wp_kses_post( $banner_output ); }

			} else {

				echo wp_kses_post( $banner_output );

			}

		}

	}
}
/* */

/* Add "Hide Featured Image on Post Page" Option */
if ( !function_exists( 'blake_von_hauer_add_meta_box' ) ) {
	function blake_von_hauer_add_meta_box() {

		add_meta_box( 'blake-von-hauer-meta-box', 'BvH Post Options', 'blake_von_hauer_meta_box_markup', array( 'post', 'page' ), 'side', 'low', null );

	}
}
add_action( 'add_meta_boxes', 'blake_von_hauer_add_meta_box' );

if ( !function_exists( 'blake_von_hauer_meta_box_markup' ) ) {
	function blake_von_hauer_meta_box_markup( $object ) {

		wp_nonce_field( basename( __FILE__ ), 'bvh-meta-box-nonce' );

		$bvh_woi_meta_box_checkbox_value = get_post_meta( $object->ID, 'bvh-woi-meta-box-checkbox', true );
		$bvh_hor_meta_box_checkbox_value = get_post_meta( $object->ID, 'bvh-hor-meta-box-checkbox', true );
		$bvh_sidebar_meta_box_checkbox_value = get_post_meta( $object->ID, 'bvh-sidebar-meta-box-checkbox', true );
		$bvh_share_meta_box_checkbox_value = get_post_meta( $object->ID, 'bvh-share-meta-box-checkbox', true ); ?>

        <?php if ( $object->post_type == 'post' ) { ?>

        <p><input name="bvh-woi-meta-box-checkbox" id="bvh-woi-meta-box-checkbox" type="checkbox" value="true"<?php if ( $bvh_woi_meta_box_checkbox_value == 'true' ) { echo ' checked'; } ?>><label for="bvh-woi-meta-box-checkbox"> Hide Featured Image on Post Page</label></p>
        <p><input name="bvh-hor-meta-box-checkbox" id="bvh-hor-meta-box-checkbox" type="checkbox" value="true"<?php if ( $bvh_hor_meta_box_checkbox_value == 'true' ) { echo ' checked'; } ?>><label for="bvh-hor-meta-box-checkbox"> Apply Horizontal Thumbnail Size</label></p>
        <p><input name="bvh-sidebar-meta-box-checkbox" id="bvh-sidebar-meta-box-checkbox" type="checkbox" value="true"<?php if ( $bvh_sidebar_meta_box_checkbox_value == 'true' ) { echo ' checked'; } ?>><label for="bvh-sidebar-meta-box-checkbox"> Hide Sidebar on Post Page</label></p>

        <?php } ?>

        <p><input name="bvh-share-meta-box-checkbox" id="bvh-share-meta-box-checkbox" type="checkbox" value="true"<?php if ( $bvh_share_meta_box_checkbox_value == 'true' ) { echo ' checked'; } ?>><label for="bvh-share-meta-box-checkbox"> Hide Share Icons on Post Page</label></p>

	<?php }
}

if ( !function_exists( 'blake_von_hauer_save_meta_box' ) ) {
	function blake_von_hauer_save_meta_box( $post_id, $post, $update ) {

		if ( !isset( $_POST['bvh-meta-box-nonce'] ) || !wp_verify_nonce( $_POST['bvh-meta-box-nonce'], basename( __FILE__ ) ) ) { return $post_id; }
		if ( !current_user_can( 'edit_post', $post_id ) ) { return $post_id; }
		if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) { return $post_id; }

		$bvh_woi_meta_box_checkbox_value = '';
		$bvh_hor_meta_box_checkbox_value = '';
		$bvh_sidebar_meta_box_checkbox_value = '';
		$bvh_share_meta_box_checkbox_value = '';

		if( isset( $_POST['bvh-woi-meta-box-checkbox'] ) ) { $bvh_woi_meta_box_checkbox_value = $_POST['bvh-woi-meta-box-checkbox']; }
		if( isset( $_POST['bvh-hor-meta-box-checkbox'] ) ) { $bvh_hor_meta_box_checkbox_value = $_POST['bvh-hor-meta-box-checkbox']; }
		if( isset( $_POST['bvh-sidebar-meta-box-checkbox'] ) ) { $bvh_sidebar_meta_box_checkbox_value = $_POST['bvh-sidebar-meta-box-checkbox']; }
		if( isset( $_POST['bvh-share-meta-box-checkbox'] ) ) { $bvh_share_meta_box_checkbox_value = $_POST['bvh-share-meta-box-checkbox']; }

		update_post_meta( $post_id, 'bvh-woi-meta-box-checkbox', $bvh_woi_meta_box_checkbox_value );
		update_post_meta( $post_id, 'bvh-hor-meta-box-checkbox', $bvh_hor_meta_box_checkbox_value );
		update_post_meta( $post_id, 'bvh-sidebar-meta-box-checkbox', $bvh_sidebar_meta_box_checkbox_value );
		update_post_meta( $post_id, 'bvh-share-meta-box-checkbox', $bvh_share_meta_box_checkbox_value );

	}
}
add_action( 'save_post', 'blake_von_hauer_save_meta_box', 10, 3 );
/* */

?>
