<?php
/*
Plugin Name: Burnhambox - BvH Slider
Plugin URI: http://www.burnhambox.com
Description: Blake von Hauer Slider.
Version: 1.0
Author: Burnhambox
Author URI: http://www.burnhambox.com
License: GNU
*/

/* SLIDER */
if ( !function_exists( 'blake_von_hauer_create_slider_posttype' ) ) {
	function blake_von_hauer_create_slider_posttype() {

		$labels = array(
			'add_new_item' => 'Add New Slide'
		);

		$args = array(
			'labels' => $labels,
			'public' => false,
			'show_ui' => true,
			'menu_icon' => 'dashicons-images-alt',
			'capability_type' => 'page',
			'rewrite' => array( 'slide-group', 'post_tag' ),
			'label'  => 'BvH Slider',
			'supports' => array( 'title', 'custom-fields', 'thumbnail', 'page-attributes' ),
		);

		register_post_type( 'slider', $args );

	}
}

add_action( 'init', 'blake_von_hauer_create_slider_posttype' );

//

if ( !function_exists( 'blake_von_hauer_create_slider_location_tax' ) ) {
	function blake_von_hauer_create_slider_location_tax() {

		register_taxonomy( 'slide-group', 'slider', array(
				'label' => 'Slide Groups',
				'public' => false,
				'show_ui' => true,
				'show_admin_column' => true,
				'rewrite' => false
			)
		);

	}
}

add_action( 'init', 'blake_von_hauer_create_slider_location_tax' );

//

if ( !function_exists( 'blake_von_hauer_set_default_slidermeta' ) ) {
	function blake_von_hauer_set_default_slidermeta( $post_ID ) {

		add_post_meta( $post_ID, 'BvH-Slider-URL', 'http://', true );
		add_post_meta( $post_ID, 'BvH-Slider-Target', '_self', true );
		add_post_meta( $post_ID, 'BvH-Slider-Excerpt', 'Lorem ipsum dolor sit amet.', true );
		add_post_meta( $post_ID, 'BvH-Slider-Post-ID', 0, true );

		return $post_ID;

	}
}

add_action( 'wp_insert_post', 'blake_von_hauer_set_default_slidermeta' );

//

if ( !function_exists( 'blake_von_hauer_getExcerptByID' ) ) {
	function blake_von_hauer_getExcerptByID( $post_id ) {

		global $post;
		$save_post = $post;
		$post = get_post( $post_id );
		$output = get_the_excerpt();
		$post = $save_post;
		return $output;

	}
}

//

if ( !function_exists( 'blake_von_hauer_slider_shortcode' ) ) {
	function blake_von_hauer_slider_shortcode( $atts = null ) {

		global $add_my_script, $ss_atts;
		$add_my_script = true;
		$ss_atts = shortcode_atts(
			array(
				'group' => '',
				'limit' => -1,
			), $atts, 'bvhslider'
		);

		$args = array(
			'post_type' => 'slider',
			'posts_per_page' => $ss_atts['limit'],
			'orderby' => 'menu_order',
			'order' => 'ASC'
		);

		if ( $ss_atts['group'] != '' ) {

			$args['tax_query'] = array(
				array( 'taxonomy' => 'slide-group', 'field' => 'slug', 'terms' => $ss_atts['group'] )
			);

		}

		$the_query = new WP_Query( $args );
		$slides = array();

		$blake_von_hauer_opt_bxControls = get_theme_mod( 'blake_von_hauer_opt_bxControls_Main', 'both' );
		$blake_von_hauer_sliderHeight = get_theme_mod( 'blake_von_hauer_sliderHeight', 600 );

		if ( $the_query->have_posts() ) {

			while ( $the_query->have_posts() ) {

				$the_query->the_post();
				$slide_callPost = false;
				$actual_base_ID = get_the_ID();
				$slide_postID = get_post_meta( get_the_ID(), 'BvH-Slider-Post-ID', true );

				if ( $slide_postID != 0 && $slide_postID != '' ) {

					$actual_base_ID = $slide_postID;
					$url = get_the_permalink( $actual_base_ID );

					if ( get_post_meta( get_the_ID(), 'BvH-Slider-Excerpt', true ) ) {

						$caption_text = get_post_meta( get_the_ID(), 'BvH-Slider-Excerpt', true );

					} else {

						$caption_text = blake_von_hauer_getExcerptByID( $actual_base_ID );

					}

					if ( get_post_thumbnail_id( get_the_ID() ) ) {

						$img_path = wp_get_attachment_image_src( get_post_thumbnail_id( get_the_ID() ), 'bvh-slider-image' );

					} else {

						$img_path = wp_get_attachment_image_src( get_post_thumbnail_id( $actual_base_ID ), 'bvh-slider-image' );

					}

				} else {

					$url = get_post_meta( get_the_ID(), 'BvH-Slider-URL', true );
					$caption_text = get_post_meta( get_the_ID(), 'BvH-Slider-Excerpt', true );
					$img_path = wp_get_attachment_image_src( get_post_thumbnail_id( get_the_ID() ), 'bvh-slider-image' );

				}

				$button_target = get_post_meta( get_the_ID(), 'BvH-Slider-Target', true );

				$linker_open = '';
				$linker_close = '';
				$padding_if_not_empty = '';

				$slide_image = get_template_directory_uri() . '/css/images/image-placeholder.jpg';
				$header = '';

				$replaceCaptionReadMore = '/\<a class="btnReadMore(.*)\<\/a>/';
				$caption_final_text = preg_replace( $replaceCaptionReadMore, '', $caption_text );

				$caption = '';
				$padding_caption = '';

				$date = '';
				$author = '';
				$comment_icon = '';
				$padding_author = '';
				$padding_comment_icon = '';
				$categories = '';

				//

				if ( $url != '' && $url != 'http://' ) {

					$linker_open = '<a class="slide-a" href="' . esc_url( $url ) . '" target="' . esc_attr( $button_target ) . '">';
					$linker_close = '</a>';
				}

				//

				if ( $img_path ) {

					$slide_image = $img_path[0];

				}

				//

				if ( get_the_title() ) {

					$header = '<div class="slider-header blake-von-hauer-font-1">' . get_the_title() . '</div>';
					$padding_caption = 'padding-top: 10px; padding-bottom: 5px;';

				} else {

					if ( get_the_title( $actual_base_ID ) ) {

						$header = '<div class="slider-header blake-von-hauer-font-1">' . get_the_title( $actual_base_ID ) . '</div>';
						$padding_caption = 'padding-top: 10px; padding-bottom: 5px;';

					}

				}

				//

				if ( $caption_text && get_theme_mod( 'blake_von_hauer_bptsCaption', 1 ) ) {

					$caption = '<div class="slider-caption blake-von-hauer-font-2" style="' . esc_attr( $padding_caption ) . '">' . esc_attr( $caption_final_text ) . '</div>';

				}

				//

				if ( get_theme_mod( 'blake_von_hauer_bptsDate', 1 ) ) {

					$date = '<div class="slider-date blake-von-hauer-font-3 fs14 fst-italic fw700 uppr">' . get_the_date( '', $actual_base_ID ) . '</div>';
					$padding_comment_icon = 'margin-left: 25px;';

				}

				//

				$post_author_id = get_post_field( 'post_author', $actual_base_ID );

				if ( get_theme_mod( 'blake_von_hauer_bptsAuthor', 1 ) ) {

					if ( $date ) { $padding_author = 'margin-left: 10px;'; }

					$author = '<div class="slider-author-outer" style="' . esc_attr( $padding_author ) . '"><div class="slider-author blake-von-hauer-font-3 fs14 fst-italic fw700 uppr">/ ' . get_the_author_meta( 'display_name', $post_author_id ) . ' /</div></div>';

				}

				//

				if ( get_theme_mod( 'blake_von_hauer_bptsComment', 1 ) && comments_open( $actual_base_ID ) ) {

					if ( $author ) { $padding_comment_icon = 'margin-left: 10px;'; }
					if ( !$date && $author ) { $padding_comment_icon = 'margin-left: 25px;'; }

					$comment_icon = '<div class="slider-comment-icon blake-von-hauer-font-3" style="' . esc_attr( $padding_comment_icon ) . '"><div class="slider-comment-icon-inner fs14"><i class="fa fa-comment"></i></div><div class="slider-comment-icon-number fs14 fst-italic fw700">' . get_comments_number( $actual_base_ID ) . '</div></div>';

				}

				//

				$categories = '<div class="slider-categories blake-von-hauer-font-3 fs14 fst-italic fw700 uppr">';

				$blake_von_hauer_categories = get_the_category( $actual_base_ID );
				$blake_von_hauer_separator = ', ';
				$blake_von_hauer_output = '';

				if ( $blake_von_hauer_categories && get_theme_mod( 'blake_von_hauer_bptsCategories', 1 ) ) {

					foreach( $blake_von_hauer_categories as $blake_von_hauer_category ) {

						$blake_von_hauer_output .= esc_attr( $blake_von_hauer_category->cat_name ) . wp_kses_post( $blake_von_hauer_separator );

					}

					$categories .= trim( $blake_von_hauer_output, $blake_von_hauer_separator );

					$categories .= '</div>';

				} else {

					$categories = '';

				}

				//

				if ( $caption || $header || $date || $author || $comment_icon || $categories ) { $padding_if_not_empty = ' slide-text-padding'; }

				$slide_info = 'slide-info';

				//

				$slides[] = '
				<li>' . wp_kses_post( $linker_open ) . '<div class="slide-container" style="background-image: url(' . esc_url( $slide_image ) . '); height: ' . esc_attr( $blake_von_hauer_sliderHeight ) . 'px;">
					<div class="slide-info-outer">
						<div class="' . esc_attr( $slide_info ) . '">
							<div class="slide-info-inner">
								<div class="slide-text-outer">
									<div class="slide-text' . esc_attr( $padding_if_not_empty ) . '">' . wp_kses_post( $date ) . wp_kses_post( $author ) . wp_kses_post( $comment_icon ) . wp_kses_post( $header ) . wp_kses_post( $caption ) . wp_kses_post( $categories ) . '</div>
								</div>
							</div>
						</div>
					</div>
				</div>' . wp_kses_post( $linker_close ) . '</li>';

			}

		}

		wp_reset_query();

		return '<div class="bvh-slider-container clearfix"><ul class="bxslider-main" style="overflow: hidden; height: ' . esc_attr( $blake_von_hauer_sliderHeight ) . 'px;">' . implode( '', $slides ) . '</ul></div>';

	}
}

add_shortcode( 'bvhslider', 'blake_von_hauer_slider_shortcode' );
/* */
?>
